<?php

$benchmarks = array('IntegerLoop', 'Fibonacci', 'Dispatch', 'Bounce', 'Loop', 'Permute', 'Queens', 'List', 'Recurse',
        'Storage', 'Sieve', 'BubbleSort', 'QuickSort', 'Sum', 'Towers', 'TreeSort');
$csoms = array(	'trunk' => 'trunk',
		'smarr-trunk' => 'smarr/trunk',
		'feature-basic' => 'smarr/features/basic',
		'feature-gc'	=> 'smarr/features/gc',
		'feature-green' => 'smarr/features/green',
		'feature-image' => 'smarr/features/image',
		'feature-pthreads' => 'smarr/features/pthreads',
		'feature-refcount' => 'smarr/features/refcount',
		'feature-tagged-int-one' => 'smarr/features/tagged-int-one',
		'feature-threading' => 'smarr/features/threading',
		'aop-basic'	=> 'smarr/aop/basic',
		'aop-basic-wo-ac' => 'smarr/aop/basic-wo-ac',
		'aop-gc'     => 'smarr/aop/gc',
		'aop-green'     => 'smarr/aop/green',
		'aop-image'     => 'smarr/aop/image',
		'aop-pthreads'     => 'smarr/aop/pthreads',
		'aop-refcount'     => 'smarr/aop/refcount',
		'aop-tagged-int-one' => 'smarr/aop/tagged-int-one',
		'aop-threading'     => 'smarr/aop/threading',

		);
$base = '/home/smarr/csom/';

foreach ($csoms as $name => $csomPath) {
  echo $base.$csomPath."\n";
  chdir($base.$csomPath);

  echo "All\n";
  exec("./CSOM -cp Smalltalk Examples/Benchmarks/All.som > $base$name.bench.log");

  foreach($benchmarks as $bench) {
    echo "$bench\n";
    for ($i = 0; $i < 10; $i++) {
      echo "$i";
      exec("./CSOM -cp Smalltalk Examples/Benchmarks/$bench.som >> $base$name.$bench.log");
    }
    echo "\n";
  }
}


echo "Job finished";
for ($i = 0; $i < 100; $i++) {
  echo chr(7);
  sleep(1);
  echo '.';
}
