// $ANTLR 3.0.1 /VMADL.j/src/de/sm/aspectc/AspectC.g 2008-08-03 15:35:11

  package de.sm.aspectc;
  
  import java.io.File;


import org.antlr.runtime.*;
import java.util.Stack;
import java.util.List;
import java.util.ArrayList;


import org.antlr.runtime.tree.*;

public class AspectCParser extends Parser {
    public static final String[] tokenNames = new String[] {
        "<invalid>", "<EOR>", "<DOWN>", "<UP>", "ADVICE", "ASPECT", "POINTCUT", "STATIC", "EXTERN", "CONST", "HEXPREFIX", "RESTRICT", "NEWLINE", "IDENTIFIER", "LBRACE", "RBRACE", "SEMICOLON", "HASH", "PPCONTINUE", "LETTER", "DIGIT", "LPARENTHESIS", "RPARENTHESIS", "SPECIAL", "WS", "COMMENT", "ML_COMMENT"
    };
    public static final int RBRACE=15;
    public static final int STATIC=7;
    public static final int LETTER=19;
    public static final int CONST=9;
    public static final int LBRACE=14;
    public static final int HASH=17;
    public static final int EXTERN=8;
    public static final int RPARENTHESIS=22;
    public static final int SEMICOLON=16;
    public static final int EOF=-1;
    public static final int LPARENTHESIS=21;
    public static final int ADVICE=4;
    public static final int RESTRICT=11;
    public static final int POINTCUT=6;
    public static final int ML_COMMENT=26;
    public static final int WS=24;
    public static final int NEWLINE=12;
    public static final int PPCONTINUE=18;
    public static final int SPECIAL=23;
    public static final int IDENTIFIER=13;
    public static final int DIGIT=20;
    public static final int COMMENT=25;
    public static final int ASPECT=5;
    public static final int HEXPREFIX=10;

        public AspectCParser(TokenStream input) {
            super(input);
        }
        
    protected TreeAdaptor adaptor = new CommonTreeAdaptor();

    public void setTreeAdaptor(TreeAdaptor adaptor) {
        this.adaptor = adaptor;
    }
    public TreeAdaptor getTreeAdaptor() {
        return adaptor;
    }

    public String[] getTokenNames() { return tokenNames; }
    public String getGrammarFileName() { return "/VMADL.j/src/de/sm/aspectc/AspectC.g"; }


    	private File parsedFile;
      
      /**
      * Make like error reporting for parser errors allows to benefit
      * from IDE make integration.
      */
      @Override
      public void reportError(RecognitionException re) {
        String errorMsg = "";
        if (parsedFile != null) {
          errorMsg += parsedFile.getAbsolutePath();
        }
        
        errorMsg += ":" + re.line + ": warning: Non critical parse error, file is ignored: ";
        System.err.print(errorMsg);
        super.reportError(re);
      }
      
      /**
      * Set the file which is actually parsed.
      * Is used to be able to generate meaningful error messages.
      * Is not used for parsing at all.
      */
      public void setParsedFile(File file) {
        parsedFile = file;
      }

    	private int adviceCount = 0;
    	private int pointcutCount = 0;
      
      public int getAdviceCount() {
        return adviceCount;
      }
      
      public int getPointcutCount() {
        return pointcutCount;
      }


    public static class aspectDefinition_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start aspectDefinition
    // /VMADL.j/src/de/sm/aspectc/AspectC.g:69:0: aspectDefinition : ( preprocessor | aspect | NEWLINE )* EOF ;
    public final aspectDefinition_return aspectDefinition() throws RecognitionException {
        aspectDefinition_return retval = new aspectDefinition_return();
        retval.start = input.LT(1);

        Object root_0 = null;

        Token NEWLINE3=null;
        Token EOF4=null;
        preprocessor_return preprocessor1 = null;

        aspect_return aspect2 = null;


        Object NEWLINE3_tree=null;
        Object EOF4_tree=null;

        try {
            // /VMADL.j/src/de/sm/aspectc/AspectC.g:69:17: ( ( preprocessor | aspect | NEWLINE )* EOF )
            // /VMADL.j/src/de/sm/aspectc/AspectC.g:70:3: ( preprocessor | aspect | NEWLINE )* EOF
            {
            root_0 = (Object)adaptor.nil();

            // /VMADL.j/src/de/sm/aspectc/AspectC.g:70:3: ( preprocessor | aspect | NEWLINE )*
            loop1:
            do {
                int alt1=4;
                switch ( input.LA(1) ) {
                case HASH:
                    {
                    alt1=1;
                    }
                    break;
                case ASPECT:
                    {
                    alt1=2;
                    }
                    break;
                case NEWLINE:
                    {
                    alt1=3;
                    }
                    break;

                }

                switch (alt1) {
            	case 1 :
            	    // /VMADL.j/src/de/sm/aspectc/AspectC.g:70:5: preprocessor
            	    {
            	    pushFollow(FOLLOW_preprocessor_in_aspectDefinition162);
            	    preprocessor1=preprocessor();
            	    _fsp--;

            	    adaptor.addChild(root_0, preprocessor1.getTree());

            	    }
            	    break;
            	case 2 :
            	    // /VMADL.j/src/de/sm/aspectc/AspectC.g:70:20: aspect
            	    {
            	    pushFollow(FOLLOW_aspect_in_aspectDefinition166);
            	    aspect2=aspect();
            	    _fsp--;

            	    adaptor.addChild(root_0, aspect2.getTree());

            	    }
            	    break;
            	case 3 :
            	    // /VMADL.j/src/de/sm/aspectc/AspectC.g:70:29: NEWLINE
            	    {
            	    NEWLINE3=(Token)input.LT(1);
            	    match(input,NEWLINE,FOLLOW_NEWLINE_in_aspectDefinition170); 
            	    NEWLINE3_tree = (Object)adaptor.create(NEWLINE3);
            	    adaptor.addChild(root_0, NEWLINE3_tree);


            	    }
            	    break;

            	default :
            	    break loop1;
                }
            } while (true);

            EOF4=(Token)input.LT(1);
            match(input,EOF,FOLLOW_EOF_in_aspectDefinition175); 
            EOF4_tree = (Object)adaptor.create(EOF4);
            adaptor.addChild(root_0, EOF4_tree);


            }

            retval.stop = input.LT(-1);

                retval.tree = (Object)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end aspectDefinition

    public static class aspect_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start aspect
    // /VMADL.j/src/de/sm/aspectc/AspectC.g:73:0: aspect : ASPECT IDENTIFIER LBRACE ( advice | pointcut | NEWLINE )* RBRACE SEMICOLON ;
    public final aspect_return aspect() throws RecognitionException {
        aspect_return retval = new aspect_return();
        retval.start = input.LT(1);

        Object root_0 = null;

        Token ASPECT5=null;
        Token IDENTIFIER6=null;
        Token LBRACE7=null;
        Token NEWLINE10=null;
        Token RBRACE11=null;
        Token SEMICOLON12=null;
        advice_return advice8 = null;

        pointcut_return pointcut9 = null;


        Object ASPECT5_tree=null;
        Object IDENTIFIER6_tree=null;
        Object LBRACE7_tree=null;
        Object NEWLINE10_tree=null;
        Object RBRACE11_tree=null;
        Object SEMICOLON12_tree=null;

        try {
            // /VMADL.j/src/de/sm/aspectc/AspectC.g:73:7: ( ASPECT IDENTIFIER LBRACE ( advice | pointcut | NEWLINE )* RBRACE SEMICOLON )
            // /VMADL.j/src/de/sm/aspectc/AspectC.g:74:2: ASPECT IDENTIFIER LBRACE ( advice | pointcut | NEWLINE )* RBRACE SEMICOLON
            {
            root_0 = (Object)adaptor.nil();

            ASPECT5=(Token)input.LT(1);
            match(input,ASPECT,FOLLOW_ASPECT_in_aspect184); 
            ASPECT5_tree = (Object)adaptor.create(ASPECT5);
            adaptor.addChild(root_0, ASPECT5_tree);

            IDENTIFIER6=(Token)input.LT(1);
            match(input,IDENTIFIER,FOLLOW_IDENTIFIER_in_aspect186); 
            IDENTIFIER6_tree = (Object)adaptor.create(IDENTIFIER6);
            adaptor.addChild(root_0, IDENTIFIER6_tree);

            LBRACE7=(Token)input.LT(1);
            match(input,LBRACE,FOLLOW_LBRACE_in_aspect188); 
            LBRACE7_tree = (Object)adaptor.create(LBRACE7);
            adaptor.addChild(root_0, LBRACE7_tree);

            // /VMADL.j/src/de/sm/aspectc/AspectC.g:75:2: ( advice | pointcut | NEWLINE )*
            loop2:
            do {
                int alt2=4;
                switch ( input.LA(1) ) {
                case ADVICE:
                    {
                    alt2=1;
                    }
                    break;
                case POINTCUT:
                    {
                    alt2=2;
                    }
                    break;
                case NEWLINE:
                    {
                    alt2=3;
                    }
                    break;

                }

                switch (alt2) {
            	case 1 :
            	    // /VMADL.j/src/de/sm/aspectc/AspectC.g:75:4: advice
            	    {
            	    pushFollow(FOLLOW_advice_in_aspect194);
            	    advice8=advice();
            	    _fsp--;

            	    adaptor.addChild(root_0, advice8.getTree());

            	    }
            	    break;
            	case 2 :
            	    // /VMADL.j/src/de/sm/aspectc/AspectC.g:75:13: pointcut
            	    {
            	    pushFollow(FOLLOW_pointcut_in_aspect198);
            	    pointcut9=pointcut();
            	    _fsp--;

            	    adaptor.addChild(root_0, pointcut9.getTree());

            	    }
            	    break;
            	case 3 :
            	    // /VMADL.j/src/de/sm/aspectc/AspectC.g:75:24: NEWLINE
            	    {
            	    NEWLINE10=(Token)input.LT(1);
            	    match(input,NEWLINE,FOLLOW_NEWLINE_in_aspect202); 
            	    NEWLINE10_tree = (Object)adaptor.create(NEWLINE10);
            	    adaptor.addChild(root_0, NEWLINE10_tree);


            	    }
            	    break;

            	default :
            	    break loop2;
                }
            } while (true);

            RBRACE11=(Token)input.LT(1);
            match(input,RBRACE,FOLLOW_RBRACE_in_aspect209); 
            RBRACE11_tree = (Object)adaptor.create(RBRACE11);
            adaptor.addChild(root_0, RBRACE11_tree);

            SEMICOLON12=(Token)input.LT(1);
            match(input,SEMICOLON,FOLLOW_SEMICOLON_in_aspect211); 
            SEMICOLON12_tree = (Object)adaptor.create(SEMICOLON12);
            adaptor.addChild(root_0, SEMICOLON12_tree);


            }

            retval.stop = input.LT(-1);

                retval.tree = (Object)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end aspect

    public static class advice_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start advice
    // /VMADL.j/src/de/sm/aspectc/AspectC.g:79:0: advice : ADVICE adviceHeader content ;
    public final advice_return advice() throws RecognitionException {
        advice_return retval = new advice_return();
        retval.start = input.LT(1);

        Object root_0 = null;

        Token ADVICE13=null;
        adviceHeader_return adviceHeader14 = null;

        content_return content15 = null;


        Object ADVICE13_tree=null;

        try {
            // /VMADL.j/src/de/sm/aspectc/AspectC.g:79:7: ( ADVICE adviceHeader content )
            // /VMADL.j/src/de/sm/aspectc/AspectC.g:80:2: ADVICE adviceHeader content
            {
            root_0 = (Object)adaptor.nil();

            ADVICE13=(Token)input.LT(1);
            match(input,ADVICE,FOLLOW_ADVICE_in_advice220); 
            ADVICE13_tree = (Object)adaptor.create(ADVICE13);
            adaptor.addChild(root_0, ADVICE13_tree);

            pushFollow(FOLLOW_adviceHeader_in_advice222);
            adviceHeader14=adviceHeader();
            _fsp--;

            adaptor.addChild(root_0, adviceHeader14.getTree());
            pushFollow(FOLLOW_content_in_advice224);
            content15=content();
            _fsp--;

            adaptor.addChild(root_0, content15.getTree());
             adviceCount++; 

            }

            retval.stop = input.LT(-1);

                retval.tree = (Object)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end advice

    public static class adviceHeader_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start adviceHeader
    // /VMADL.j/src/de/sm/aspectc/AspectC.g:84:0: adviceHeader : (~ ( LBRACE | RBRACE | SEMICOLON ) )+ ;
    public final adviceHeader_return adviceHeader() throws RecognitionException {
        adviceHeader_return retval = new adviceHeader_return();
        retval.start = input.LT(1);

        Object root_0 = null;

        Token set16=null;

        Object set16_tree=null;

        try {
            // /VMADL.j/src/de/sm/aspectc/AspectC.g:84:14: ( (~ ( LBRACE | RBRACE | SEMICOLON ) )+ )
            // /VMADL.j/src/de/sm/aspectc/AspectC.g:85:3: (~ ( LBRACE | RBRACE | SEMICOLON ) )+
            {
            root_0 = (Object)adaptor.nil();

            // /VMADL.j/src/de/sm/aspectc/AspectC.g:85:3: (~ ( LBRACE | RBRACE | SEMICOLON ) )+
            int cnt3=0;
            loop3:
            do {
                int alt3=2;
                int LA3_0 = input.LA(1);

                if ( ((LA3_0>=ADVICE && LA3_0<=IDENTIFIER)||(LA3_0>=HASH && LA3_0<=ML_COMMENT)) ) {
                    alt3=1;
                }


                switch (alt3) {
            	case 1 :
            	    // /VMADL.j/src/de/sm/aspectc/AspectC.g:85:5: ~ ( LBRACE | RBRACE | SEMICOLON )
            	    {
            	    set16=(Token)input.LT(1);
            	    if ( (input.LA(1)>=ADVICE && input.LA(1)<=IDENTIFIER)||(input.LA(1)>=HASH && input.LA(1)<=ML_COMMENT) ) {
            	        input.consume();
            	        adaptor.addChild(root_0, adaptor.create(set16));
            	        errorRecovery=false;
            	    }
            	    else {
            	        MismatchedSetException mse =
            	            new MismatchedSetException(null,input);
            	        recoverFromMismatchedSet(input,mse,FOLLOW_set_in_adviceHeader240);    throw mse;
            	    }


            	    }
            	    break;

            	default :
            	    if ( cnt3 >= 1 ) break loop3;
                        EarlyExitException eee =
                            new EarlyExitException(3, input);
                        throw eee;
                }
                cnt3++;
            } while (true);


            }

            retval.stop = input.LT(-1);

                retval.tree = (Object)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end adviceHeader

    public static class preprocessor_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start preprocessor
    // /VMADL.j/src/de/sm/aspectc/AspectC.g:88:0: preprocessor : HASH ( (~ ( PPCONTINUE | NEWLINE ) )* PPCONTINUE )* (~ ( PPCONTINUE | NEWLINE ) )* NEWLINE ;
    public final preprocessor_return preprocessor() throws RecognitionException {
        preprocessor_return retval = new preprocessor_return();
        retval.start = input.LT(1);

        Object root_0 = null;

        Token HASH17=null;
        Token set18=null;
        Token PPCONTINUE19=null;
        Token set20=null;
        Token NEWLINE21=null;

        Object HASH17_tree=null;
        Object set18_tree=null;
        Object PPCONTINUE19_tree=null;
        Object set20_tree=null;
        Object NEWLINE21_tree=null;

        try {
            // /VMADL.j/src/de/sm/aspectc/AspectC.g:88:14: ( HASH ( (~ ( PPCONTINUE | NEWLINE ) )* PPCONTINUE )* (~ ( PPCONTINUE | NEWLINE ) )* NEWLINE )
            // /VMADL.j/src/de/sm/aspectc/AspectC.g:89:3: HASH ( (~ ( PPCONTINUE | NEWLINE ) )* PPCONTINUE )* (~ ( PPCONTINUE | NEWLINE ) )* NEWLINE
            {
            root_0 = (Object)adaptor.nil();

            HASH17=(Token)input.LT(1);
            match(input,HASH,FOLLOW_HASH_in_preprocessor265); 
            HASH17_tree = (Object)adaptor.create(HASH17);
            adaptor.addChild(root_0, HASH17_tree);

            // /VMADL.j/src/de/sm/aspectc/AspectC.g:90:3: ( (~ ( PPCONTINUE | NEWLINE ) )* PPCONTINUE )*
            loop5:
            do {
                int alt5=2;
                alt5 = dfa5.predict(input);
                switch (alt5) {
            	case 1 :
            	    // /VMADL.j/src/de/sm/aspectc/AspectC.g:90:4: (~ ( PPCONTINUE | NEWLINE ) )* PPCONTINUE
            	    {
            	    // /VMADL.j/src/de/sm/aspectc/AspectC.g:90:4: (~ ( PPCONTINUE | NEWLINE ) )*
            	    loop4:
            	    do {
            	        int alt4=2;
            	        int LA4_0 = input.LA(1);

            	        if ( ((LA4_0>=ADVICE && LA4_0<=RESTRICT)||(LA4_0>=IDENTIFIER && LA4_0<=HASH)||(LA4_0>=LETTER && LA4_0<=ML_COMMENT)) ) {
            	            alt4=1;
            	        }


            	        switch (alt4) {
            	    	case 1 :
            	    	    // /VMADL.j/src/de/sm/aspectc/AspectC.g:90:5: ~ ( PPCONTINUE | NEWLINE )
            	    	    {
            	    	    set18=(Token)input.LT(1);
            	    	    if ( (input.LA(1)>=ADVICE && input.LA(1)<=RESTRICT)||(input.LA(1)>=IDENTIFIER && input.LA(1)<=HASH)||(input.LA(1)>=LETTER && input.LA(1)<=ML_COMMENT) ) {
            	    	        input.consume();
            	    	        adaptor.addChild(root_0, adaptor.create(set18));
            	    	        errorRecovery=false;
            	    	    }
            	    	    else {
            	    	        MismatchedSetException mse =
            	    	            new MismatchedSetException(null,input);
            	    	        recoverFromMismatchedSet(input,mse,FOLLOW_set_in_preprocessor271);    throw mse;
            	    	    }


            	    	    }
            	    	    break;

            	    	default :
            	    	    break loop4;
            	        }
            	    } while (true);

            	    PPCONTINUE19=(Token)input.LT(1);
            	    match(input,PPCONTINUE,FOLLOW_PPCONTINUE_in_preprocessor284); 
            	    PPCONTINUE19_tree = (Object)adaptor.create(PPCONTINUE19);
            	    adaptor.addChild(root_0, PPCONTINUE19_tree);


            	    }
            	    break;

            	default :
            	    break loop5;
                }
            } while (true);

            // /VMADL.j/src/de/sm/aspectc/AspectC.g:91:3: (~ ( PPCONTINUE | NEWLINE ) )*
            loop6:
            do {
                int alt6=2;
                int LA6_0 = input.LA(1);

                if ( ((LA6_0>=ADVICE && LA6_0<=RESTRICT)||(LA6_0>=IDENTIFIER && LA6_0<=HASH)||(LA6_0>=LETTER && LA6_0<=ML_COMMENT)) ) {
                    alt6=1;
                }


                switch (alt6) {
            	case 1 :
            	    // /VMADL.j/src/de/sm/aspectc/AspectC.g:91:4: ~ ( PPCONTINUE | NEWLINE )
            	    {
            	    set20=(Token)input.LT(1);
            	    if ( (input.LA(1)>=ADVICE && input.LA(1)<=RESTRICT)||(input.LA(1)>=IDENTIFIER && input.LA(1)<=HASH)||(input.LA(1)>=LETTER && input.LA(1)<=ML_COMMENT) ) {
            	        input.consume();
            	        adaptor.addChild(root_0, adaptor.create(set20));
            	        errorRecovery=false;
            	    }
            	    else {
            	        MismatchedSetException mse =
            	            new MismatchedSetException(null,input);
            	        recoverFromMismatchedSet(input,mse,FOLLOW_set_in_preprocessor291);    throw mse;
            	    }


            	    }
            	    break;

            	default :
            	    break loop6;
                }
            } while (true);

            NEWLINE21=(Token)input.LT(1);
            match(input,NEWLINE,FOLLOW_NEWLINE_in_preprocessor306); 
            NEWLINE21_tree = (Object)adaptor.create(NEWLINE21);
            adaptor.addChild(root_0, NEWLINE21_tree);


            }

            retval.stop = input.LT(-1);

                retval.tree = (Object)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end preprocessor

    public static class contentcontent_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start contentcontent
    // /VMADL.j/src/de/sm/aspectc/AspectC.g:95:0: contentcontent : ( content | (~ ( LBRACE | RBRACE ) )+ )* ;
    public final contentcontent_return contentcontent() throws RecognitionException {
        contentcontent_return retval = new contentcontent_return();
        retval.start = input.LT(1);

        Object root_0 = null;

        Token set23=null;
        content_return content22 = null;


        Object set23_tree=null;

        try {
            // /VMADL.j/src/de/sm/aspectc/AspectC.g:95:15: ( ( content | (~ ( LBRACE | RBRACE ) )+ )* )
            // /VMADL.j/src/de/sm/aspectc/AspectC.g:96:2: ( content | (~ ( LBRACE | RBRACE ) )+ )*
            {
            root_0 = (Object)adaptor.nil();

            // /VMADL.j/src/de/sm/aspectc/AspectC.g:96:2: ( content | (~ ( LBRACE | RBRACE ) )+ )*
            loop8:
            do {
                int alt8=3;
                int LA8_0 = input.LA(1);

                if ( (LA8_0==LBRACE) ) {
                    alt8=1;
                }
                else if ( ((LA8_0>=ADVICE && LA8_0<=IDENTIFIER)||(LA8_0>=SEMICOLON && LA8_0<=ML_COMMENT)) ) {
                    alt8=2;
                }


                switch (alt8) {
            	case 1 :
            	    // /VMADL.j/src/de/sm/aspectc/AspectC.g:96:3: content
            	    {
            	    pushFollow(FOLLOW_content_in_contentcontent316);
            	    content22=content();
            	    _fsp--;

            	    adaptor.addChild(root_0, content22.getTree());

            	    }
            	    break;
            	case 2 :
            	    // /VMADL.j/src/de/sm/aspectc/AspectC.g:96:13: (~ ( LBRACE | RBRACE ) )+
            	    {
            	    // /VMADL.j/src/de/sm/aspectc/AspectC.g:96:13: (~ ( LBRACE | RBRACE ) )+
            	    int cnt7=0;
            	    loop7:
            	    do {
            	        int alt7=2;
            	        int LA7_0 = input.LA(1);

            	        if ( ((LA7_0>=ADVICE && LA7_0<=IDENTIFIER)||(LA7_0>=SEMICOLON && LA7_0<=ML_COMMENT)) ) {
            	            alt7=1;
            	        }


            	        switch (alt7) {
            	    	case 1 :
            	    	    // /VMADL.j/src/de/sm/aspectc/AspectC.g:96:14: ~ ( LBRACE | RBRACE )
            	    	    {
            	    	    set23=(Token)input.LT(1);
            	    	    if ( (input.LA(1)>=ADVICE && input.LA(1)<=IDENTIFIER)||(input.LA(1)>=SEMICOLON && input.LA(1)<=ML_COMMENT) ) {
            	    	        input.consume();
            	    	        adaptor.addChild(root_0, adaptor.create(set23));
            	    	        errorRecovery=false;
            	    	    }
            	    	    else {
            	    	        MismatchedSetException mse =
            	    	            new MismatchedSetException(null,input);
            	    	        recoverFromMismatchedSet(input,mse,FOLLOW_set_in_contentcontent321);    throw mse;
            	    	    }


            	    	    }
            	    	    break;

            	    	default :
            	    	    if ( cnt7 >= 1 ) break loop7;
            	                EarlyExitException eee =
            	                    new EarlyExitException(7, input);
            	                throw eee;
            	        }
            	        cnt7++;
            	    } while (true);


            	    }
            	    break;

            	default :
            	    break loop8;
                }
            } while (true);


            }

            retval.stop = input.LT(-1);

                retval.tree = (Object)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end contentcontent

    public static class content_return extends ParserRuleReturnScope {
        public String content;
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start content
    // /VMADL.j/src/de/sm/aspectc/AspectC.g:98:0: content returns [String content] : LBRACE contentcontent RBRACE ;
    public final content_return content() throws RecognitionException {
        content_return retval = new content_return();
        retval.start = input.LT(1);

        Object root_0 = null;

        Token LBRACE24=null;
        Token RBRACE26=null;
        contentcontent_return contentcontent25 = null;


        Object LBRACE24_tree=null;
        Object RBRACE26_tree=null;

        try {
            // /VMADL.j/src/de/sm/aspectc/AspectC.g:98:33: ( LBRACE contentcontent RBRACE )
            // /VMADL.j/src/de/sm/aspectc/AspectC.g:99:3: LBRACE contentcontent RBRACE
            {
            root_0 = (Object)adaptor.nil();

            LBRACE24=(Token)input.LT(1);
            match(input,LBRACE,FOLLOW_LBRACE_in_content346); 
            LBRACE24_tree = (Object)adaptor.create(LBRACE24);
            adaptor.addChild(root_0, LBRACE24_tree);

            pushFollow(FOLLOW_contentcontent_in_content349);
            contentcontent25=contentcontent();
            _fsp--;

            adaptor.addChild(root_0, contentcontent25.getTree());
             retval.content = input.toString(contentcontent25.start,contentcontent25.stop); 
            RBRACE26=(Token)input.LT(1);
            match(input,RBRACE,FOLLOW_RBRACE_in_content355); 
            RBRACE26_tree = (Object)adaptor.create(RBRACE26);
            adaptor.addChild(root_0, RBRACE26_tree);


            }

            retval.stop = input.LT(-1);

                retval.tree = (Object)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end content

    public static class pointcut_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start pointcut
    // /VMADL.j/src/de/sm/aspectc/AspectC.g:105:0: pointcut : POINTCUT (~ ( SEMICOLON ) )* SEMICOLON ( NEWLINE )* ;
    public final pointcut_return pointcut() throws RecognitionException {
        pointcut_return retval = new pointcut_return();
        retval.start = input.LT(1);

        Object root_0 = null;

        Token POINTCUT27=null;
        Token set28=null;
        Token SEMICOLON29=null;
        Token NEWLINE30=null;

        Object POINTCUT27_tree=null;
        Object set28_tree=null;
        Object SEMICOLON29_tree=null;
        Object NEWLINE30_tree=null;

        try {
            // /VMADL.j/src/de/sm/aspectc/AspectC.g:105:10: ( POINTCUT (~ ( SEMICOLON ) )* SEMICOLON ( NEWLINE )* )
            // /VMADL.j/src/de/sm/aspectc/AspectC.g:106:2: POINTCUT (~ ( SEMICOLON ) )* SEMICOLON ( NEWLINE )*
            {
            root_0 = (Object)adaptor.nil();

            POINTCUT27=(Token)input.LT(1);
            match(input,POINTCUT,FOLLOW_POINTCUT_in_pointcut365); 
            POINTCUT27_tree = (Object)adaptor.create(POINTCUT27);
            adaptor.addChild(root_0, POINTCUT27_tree);

            // /VMADL.j/src/de/sm/aspectc/AspectC.g:107:2: (~ ( SEMICOLON ) )*
            loop9:
            do {
                int alt9=2;
                int LA9_0 = input.LA(1);

                if ( ((LA9_0>=ADVICE && LA9_0<=RBRACE)||(LA9_0>=HASH && LA9_0<=ML_COMMENT)) ) {
                    alt9=1;
                }


                switch (alt9) {
            	case 1 :
            	    // /VMADL.j/src/de/sm/aspectc/AspectC.g:107:3: ~ ( SEMICOLON )
            	    {
            	    set28=(Token)input.LT(1);
            	    if ( (input.LA(1)>=ADVICE && input.LA(1)<=RBRACE)||(input.LA(1)>=HASH && input.LA(1)<=ML_COMMENT) ) {
            	        input.consume();
            	        adaptor.addChild(root_0, adaptor.create(set28));
            	        errorRecovery=false;
            	    }
            	    else {
            	        MismatchedSetException mse =
            	            new MismatchedSetException(null,input);
            	        recoverFromMismatchedSet(input,mse,FOLLOW_set_in_pointcut370);    throw mse;
            	    }


            	    }
            	    break;

            	default :
            	    break loop9;
                }
            } while (true);

            SEMICOLON29=(Token)input.LT(1);
            match(input,SEMICOLON,FOLLOW_SEMICOLON_in_pointcut378); 
            SEMICOLON29_tree = (Object)adaptor.create(SEMICOLON29);
            adaptor.addChild(root_0, SEMICOLON29_tree);

            // /VMADL.j/src/de/sm/aspectc/AspectC.g:108:12: ( NEWLINE )*
            loop10:
            do {
                int alt10=2;
                int LA10_0 = input.LA(1);

                if ( (LA10_0==NEWLINE) ) {
                    alt10=1;
                }


                switch (alt10) {
            	case 1 :
            	    // /VMADL.j/src/de/sm/aspectc/AspectC.g:108:12: NEWLINE
            	    {
            	    NEWLINE30=(Token)input.LT(1);
            	    match(input,NEWLINE,FOLLOW_NEWLINE_in_pointcut380); 
            	    NEWLINE30_tree = (Object)adaptor.create(NEWLINE30);
            	    adaptor.addChild(root_0, NEWLINE30_tree);


            	    }
            	    break;

            	default :
            	    break loop10;
                }
            } while (true);

             pointcutCount++; 

            }

            retval.stop = input.LT(-1);

                retval.tree = (Object)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end pointcut


    protected DFA5 dfa5 = new DFA5(this);
    static final String DFA5_eotS =
        "\4\uffff";
    static final String DFA5_eofS =
        "\4\uffff";
    static final String DFA5_minS =
        "\2\4\2\uffff";
    static final String DFA5_maxS =
        "\2\32\2\uffff";
    static final String DFA5_acceptS =
        "\2\uffff\1\2\1\1";
    static final String DFA5_specialS =
        "\4\uffff}>";
    static final String[] DFA5_transitionS = {
            "\10\1\1\2\5\1\1\3\10\1",
            "\10\1\1\2\5\1\1\3\10\1",
            "",
            ""
    };

    static final short[] DFA5_eot = DFA.unpackEncodedString(DFA5_eotS);
    static final short[] DFA5_eof = DFA.unpackEncodedString(DFA5_eofS);
    static final char[] DFA5_min = DFA.unpackEncodedStringToUnsignedChars(DFA5_minS);
    static final char[] DFA5_max = DFA.unpackEncodedStringToUnsignedChars(DFA5_maxS);
    static final short[] DFA5_accept = DFA.unpackEncodedString(DFA5_acceptS);
    static final short[] DFA5_special = DFA.unpackEncodedString(DFA5_specialS);
    static final short[][] DFA5_transition;

    static {
        int numStates = DFA5_transitionS.length;
        DFA5_transition = new short[numStates][];
        for (int i=0; i<numStates; i++) {
            DFA5_transition[i] = DFA.unpackEncodedString(DFA5_transitionS[i]);
        }
    }

    class DFA5 extends DFA {

        public DFA5(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 5;
            this.eot = DFA5_eot;
            this.eof = DFA5_eof;
            this.min = DFA5_min;
            this.max = DFA5_max;
            this.accept = DFA5_accept;
            this.special = DFA5_special;
            this.transition = DFA5_transition;
        }
        public String getDescription() {
            return "()* loopback of 90:3: ( (~ ( PPCONTINUE | NEWLINE ) )* PPCONTINUE )*";
        }
    }
 

    public static final BitSet FOLLOW_preprocessor_in_aspectDefinition162 = new BitSet(new long[]{0x0000000000021020L});
    public static final BitSet FOLLOW_aspect_in_aspectDefinition166 = new BitSet(new long[]{0x0000000000021020L});
    public static final BitSet FOLLOW_NEWLINE_in_aspectDefinition170 = new BitSet(new long[]{0x0000000000021020L});
    public static final BitSet FOLLOW_EOF_in_aspectDefinition175 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ASPECT_in_aspect184 = new BitSet(new long[]{0x0000000000002000L});
    public static final BitSet FOLLOW_IDENTIFIER_in_aspect186 = new BitSet(new long[]{0x0000000000004000L});
    public static final BitSet FOLLOW_LBRACE_in_aspect188 = new BitSet(new long[]{0x0000000000009050L});
    public static final BitSet FOLLOW_advice_in_aspect194 = new BitSet(new long[]{0x0000000000009050L});
    public static final BitSet FOLLOW_pointcut_in_aspect198 = new BitSet(new long[]{0x0000000000009050L});
    public static final BitSet FOLLOW_NEWLINE_in_aspect202 = new BitSet(new long[]{0x0000000000009050L});
    public static final BitSet FOLLOW_RBRACE_in_aspect209 = new BitSet(new long[]{0x0000000000010000L});
    public static final BitSet FOLLOW_SEMICOLON_in_aspect211 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ADVICE_in_advice220 = new BitSet(new long[]{0x0000000007FE3FF0L});
    public static final BitSet FOLLOW_adviceHeader_in_advice222 = new BitSet(new long[]{0x0000000000004000L});
    public static final BitSet FOLLOW_content_in_advice224 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_set_in_adviceHeader240 = new BitSet(new long[]{0x0000000007FE3FF2L});
    public static final BitSet FOLLOW_HASH_in_preprocessor265 = new BitSet(new long[]{0x0000000007FFFFF0L});
    public static final BitSet FOLLOW_set_in_preprocessor271 = new BitSet(new long[]{0x0000000007FFEFF0L});
    public static final BitSet FOLLOW_PPCONTINUE_in_preprocessor284 = new BitSet(new long[]{0x0000000007FFFFF0L});
    public static final BitSet FOLLOW_set_in_preprocessor291 = new BitSet(new long[]{0x0000000007FBFFF0L});
    public static final BitSet FOLLOW_NEWLINE_in_preprocessor306 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_content_in_contentcontent316 = new BitSet(new long[]{0x0000000007FF7FF2L});
    public static final BitSet FOLLOW_set_in_contentcontent321 = new BitSet(new long[]{0x0000000007FF7FF2L});
    public static final BitSet FOLLOW_LBRACE_in_content346 = new BitSet(new long[]{0x0000000007FFFFF0L});
    public static final BitSet FOLLOW_contentcontent_in_content349 = new BitSet(new long[]{0x0000000000008000L});
    public static final BitSet FOLLOW_RBRACE_in_content355 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_POINTCUT_in_pointcut365 = new BitSet(new long[]{0x0000000007FFFFF0L});
    public static final BitSet FOLLOW_set_in_pointcut370 = new BitSet(new long[]{0x0000000007FFFFF0L});
    public static final BitSet FOLLOW_SEMICOLON_in_pointcut378 = new BitSet(new long[]{0x0000000000001002L});
    public static final BitSet FOLLOW_NEWLINE_in_pointcut380 = new BitSet(new long[]{0x0000000000001002L});

}