// $ANTLR 3.0.1 /VMADL.j/src/de/sm/csimple/CSimple.g 2008-07-27 23:12:08

  package de.sm.csimple;
  
  import java.io.File;


import org.antlr.runtime.*;
import java.util.Stack;
import java.util.List;
import java.util.ArrayList;
import java.util.Map;
import java.util.HashMap;

import org.antlr.runtime.tree.*;

public class CSimpleParser extends Parser {
    public static final String[] tokenNames = new String[] {
        "<invalid>", "<EOR>", "<DOWN>", "<UP>", "TYPEDEF", "STRUCT", "STATIC", "INLINE", "EXTERN", "CONST", "ATTR", "HEXPREFIX", "NEWLINE", "QUOTE", "IDENTIFIER", "LBRACE", "RBRACE", "DIGIT", "PPCONTINUE", "SPECIAL", "LETTER", "WS", "COMMENT", "ML_COMMENT", "'['", "']'", "'='", "';'", "'#'", "'('", "')'", "'*'", "'a'", "'f'", "'A'", "'F'"
    };
    public static final int RBRACE=16;
    public static final int LETTER=20;
    public static final int STATIC=6;
    public static final int CONST=9;
    public static final int TYPEDEF=4;
    public static final int LBRACE=15;
    public static final int EXTERN=8;
    public static final int STRUCT=5;
    public static final int EOF=-1;
    public static final int ML_COMMENT=23;
    public static final int QUOTE=13;
    public static final int WS=21;
    public static final int NEWLINE=12;
    public static final int PPCONTINUE=18;
    public static final int SPECIAL=19;
    public static final int IDENTIFIER=14;
    public static final int INLINE=7;
    public static final int DIGIT=17;
    public static final int COMMENT=22;
    public static final int ATTR=10;
    public static final int HEXPREFIX=11;

        public CSimpleParser(TokenStream input) {
            super(input);
            ruleMemo = new HashMap[61+1];
         }
        
    protected TreeAdaptor adaptor = new CommonTreeAdaptor();

    public void setTreeAdaptor(TreeAdaptor adaptor) {
        this.adaptor = adaptor;
    }
    public TreeAdaptor getTreeAdaptor() {
        return adaptor;
    }

    public String[] getTokenNames() { return tokenNames; }
    public String getGrammarFileName() { return "/VMADL.j/src/de/sm/csimple/CSimple.g"; }


    	private List<String> functions = new ArrayList<String>();
    	
    	public List<String> getFuntions() {
    		return functions;
    	}
    	
    	private File parsedFile;
      
      /**
      * Make like error reporting for parser errors allows to benefit
      * from IDE make integration.
      */
      @Override
      public void reportError(RecognitionException re) {
        String errorMsg = "";
        if (parsedFile != null) {
          errorMsg += parsedFile.getAbsolutePath();
        }
        
        errorMsg += ":" + re.line + ": warning: Non critical parse error, file is ignored: ";
        System.err.print(errorMsg);
        super.reportError(re);
      }
      
      /**
      * Set the file which is actually parsed.
      * Is used to be able to generate meaningful error messages.
      * Is not used for parsing at all.
      */
      public void setParsedFile(File file) {
        parsedFile = file;
      }


    public static class definitions_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start definitions
    // /VMADL.j/src/de/sm/csimple/CSimple.g:74:0: definitions : ( typedefinition | struct | function | preprocessor | variable | NEWLINE | externDef )* EOF ;
    public final definitions_return definitions() throws RecognitionException {
        definitions_return retval = new definitions_return();
        retval.start = input.LT(1);

        Object root_0 = null;

        Token NEWLINE6=null;
        Token EOF8=null;
        typedefinition_return typedefinition1 = null;

        struct_return struct2 = null;

        function_return function3 = null;

        preprocessor_return preprocessor4 = null;

        variable_return variable5 = null;

        externDef_return externDef7 = null;


        Object NEWLINE6_tree=null;
        Object EOF8_tree=null;

        try {
            // /VMADL.j/src/de/sm/csimple/CSimple.g:74:12: ( ( typedefinition | struct | function | preprocessor | variable | NEWLINE | externDef )* EOF )
            // /VMADL.j/src/de/sm/csimple/CSimple.g:75:2: ( typedefinition | struct | function | preprocessor | variable | NEWLINE | externDef )* EOF
            {
            root_0 = (Object)adaptor.nil();

            // /VMADL.j/src/de/sm/csimple/CSimple.g:75:2: ( typedefinition | struct | function | preprocessor | variable | NEWLINE | externDef )*
            loop1:
            do {
                int alt1=8;
                alt1 = dfa1.predict(input);
                switch (alt1) {
            	case 1 :
            	    // /VMADL.j/src/de/sm/csimple/CSimple.g:75:3: typedefinition
            	    {
            	    pushFollow(FOLLOW_typedefinition_in_definitions178);
            	    typedefinition1=typedefinition();
            	    _fsp--;
            	    if (failed) return retval;
            	    if ( backtracking==0 ) adaptor.addChild(root_0, typedefinition1.getTree());

            	    }
            	    break;
            	case 2 :
            	    // /VMADL.j/src/de/sm/csimple/CSimple.g:75:20: struct
            	    {
            	    pushFollow(FOLLOW_struct_in_definitions182);
            	    struct2=struct();
            	    _fsp--;
            	    if (failed) return retval;
            	    if ( backtracking==0 ) adaptor.addChild(root_0, struct2.getTree());

            	    }
            	    break;
            	case 3 :
            	    // /VMADL.j/src/de/sm/csimple/CSimple.g:75:29: function
            	    {
            	    pushFollow(FOLLOW_function_in_definitions186);
            	    function3=function();
            	    _fsp--;
            	    if (failed) return retval;
            	    if ( backtracking==0 ) adaptor.addChild(root_0, function3.getTree());

            	    }
            	    break;
            	case 4 :
            	    // /VMADL.j/src/de/sm/csimple/CSimple.g:75:40: preprocessor
            	    {
            	    pushFollow(FOLLOW_preprocessor_in_definitions190);
            	    preprocessor4=preprocessor();
            	    _fsp--;
            	    if (failed) return retval;
            	    if ( backtracking==0 ) adaptor.addChild(root_0, preprocessor4.getTree());

            	    }
            	    break;
            	case 5 :
            	    // /VMADL.j/src/de/sm/csimple/CSimple.g:75:55: variable
            	    {
            	    pushFollow(FOLLOW_variable_in_definitions194);
            	    variable5=variable();
            	    _fsp--;
            	    if (failed) return retval;
            	    if ( backtracking==0 ) adaptor.addChild(root_0, variable5.getTree());

            	    }
            	    break;
            	case 6 :
            	    // /VMADL.j/src/de/sm/csimple/CSimple.g:75:66: NEWLINE
            	    {
            	    NEWLINE6=(Token)input.LT(1);
            	    match(input,NEWLINE,FOLLOW_NEWLINE_in_definitions198); if (failed) return retval;
            	    if ( backtracking==0 ) {
            	    NEWLINE6_tree = (Object)adaptor.create(NEWLINE6);
            	    adaptor.addChild(root_0, NEWLINE6_tree);
            	    }

            	    }
            	    break;
            	case 7 :
            	    // /VMADL.j/src/de/sm/csimple/CSimple.g:75:76: externDef
            	    {
            	    pushFollow(FOLLOW_externDef_in_definitions202);
            	    externDef7=externDef();
            	    _fsp--;
            	    if (failed) return retval;
            	    if ( backtracking==0 ) adaptor.addChild(root_0, externDef7.getTree());

            	    }
            	    break;

            	default :
            	    break loop1;
                }
            } while (true);

            EOF8=(Token)input.LT(1);
            match(input,EOF,FOLLOW_EOF_in_definitions208); if (failed) return retval;
            if ( backtracking==0 ) {
            EOF8_tree = (Object)adaptor.create(EOF8);
            adaptor.addChild(root_0, EOF8_tree);
            }

            }

            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (Object)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end definitions

    public static class externDef_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start externDef
    // /VMADL.j/src/de/sm/csimple/CSimple.g:79:0: externDef : EXTERN QUOTE IDENTIFIER QUOTE LBRACE ( typedefinition | struct | function | preprocessor | variable | NEWLINE )* RBRACE ;
    public final externDef_return externDef() throws RecognitionException {
        externDef_return retval = new externDef_return();
        retval.start = input.LT(1);

        Object root_0 = null;

        Token EXTERN9=null;
        Token QUOTE10=null;
        Token IDENTIFIER11=null;
        Token QUOTE12=null;
        Token LBRACE13=null;
        Token NEWLINE19=null;
        Token RBRACE20=null;
        typedefinition_return typedefinition14 = null;

        struct_return struct15 = null;

        function_return function16 = null;

        preprocessor_return preprocessor17 = null;

        variable_return variable18 = null;


        Object EXTERN9_tree=null;
        Object QUOTE10_tree=null;
        Object IDENTIFIER11_tree=null;
        Object QUOTE12_tree=null;
        Object LBRACE13_tree=null;
        Object NEWLINE19_tree=null;
        Object RBRACE20_tree=null;

        try {
            // /VMADL.j/src/de/sm/csimple/CSimple.g:79:10: ( EXTERN QUOTE IDENTIFIER QUOTE LBRACE ( typedefinition | struct | function | preprocessor | variable | NEWLINE )* RBRACE )
            // /VMADL.j/src/de/sm/csimple/CSimple.g:80:3: EXTERN QUOTE IDENTIFIER QUOTE LBRACE ( typedefinition | struct | function | preprocessor | variable | NEWLINE )* RBRACE
            {
            root_0 = (Object)adaptor.nil();

            EXTERN9=(Token)input.LT(1);
            match(input,EXTERN,FOLLOW_EXTERN_in_externDef218); if (failed) return retval;
            if ( backtracking==0 ) {
            EXTERN9_tree = (Object)adaptor.create(EXTERN9);
            adaptor.addChild(root_0, EXTERN9_tree);
            }
            QUOTE10=(Token)input.LT(1);
            match(input,QUOTE,FOLLOW_QUOTE_in_externDef220); if (failed) return retval;
            if ( backtracking==0 ) {
            QUOTE10_tree = (Object)adaptor.create(QUOTE10);
            adaptor.addChild(root_0, QUOTE10_tree);
            }
            IDENTIFIER11=(Token)input.LT(1);
            match(input,IDENTIFIER,FOLLOW_IDENTIFIER_in_externDef222); if (failed) return retval;
            if ( backtracking==0 ) {
            IDENTIFIER11_tree = (Object)adaptor.create(IDENTIFIER11);
            adaptor.addChild(root_0, IDENTIFIER11_tree);
            }
            QUOTE12=(Token)input.LT(1);
            match(input,QUOTE,FOLLOW_QUOTE_in_externDef224); if (failed) return retval;
            if ( backtracking==0 ) {
            QUOTE12_tree = (Object)adaptor.create(QUOTE12);
            adaptor.addChild(root_0, QUOTE12_tree);
            }
            LBRACE13=(Token)input.LT(1);
            match(input,LBRACE,FOLLOW_LBRACE_in_externDef229); if (failed) return retval;
            if ( backtracking==0 ) {
            LBRACE13_tree = (Object)adaptor.create(LBRACE13);
            adaptor.addChild(root_0, LBRACE13_tree);
            }
            // /VMADL.j/src/de/sm/csimple/CSimple.g:82:3: ( typedefinition | struct | function | preprocessor | variable | NEWLINE )*
            loop2:
            do {
                int alt2=7;
                alt2 = dfa2.predict(input);
                switch (alt2) {
            	case 1 :
            	    // /VMADL.j/src/de/sm/csimple/CSimple.g:82:4: typedefinition
            	    {
            	    pushFollow(FOLLOW_typedefinition_in_externDef234);
            	    typedefinition14=typedefinition();
            	    _fsp--;
            	    if (failed) return retval;
            	    if ( backtracking==0 ) adaptor.addChild(root_0, typedefinition14.getTree());

            	    }
            	    break;
            	case 2 :
            	    // /VMADL.j/src/de/sm/csimple/CSimple.g:82:21: struct
            	    {
            	    pushFollow(FOLLOW_struct_in_externDef238);
            	    struct15=struct();
            	    _fsp--;
            	    if (failed) return retval;
            	    if ( backtracking==0 ) adaptor.addChild(root_0, struct15.getTree());

            	    }
            	    break;
            	case 3 :
            	    // /VMADL.j/src/de/sm/csimple/CSimple.g:82:30: function
            	    {
            	    pushFollow(FOLLOW_function_in_externDef242);
            	    function16=function();
            	    _fsp--;
            	    if (failed) return retval;
            	    if ( backtracking==0 ) adaptor.addChild(root_0, function16.getTree());

            	    }
            	    break;
            	case 4 :
            	    // /VMADL.j/src/de/sm/csimple/CSimple.g:82:41: preprocessor
            	    {
            	    pushFollow(FOLLOW_preprocessor_in_externDef246);
            	    preprocessor17=preprocessor();
            	    _fsp--;
            	    if (failed) return retval;
            	    if ( backtracking==0 ) adaptor.addChild(root_0, preprocessor17.getTree());

            	    }
            	    break;
            	case 5 :
            	    // /VMADL.j/src/de/sm/csimple/CSimple.g:82:56: variable
            	    {
            	    pushFollow(FOLLOW_variable_in_externDef250);
            	    variable18=variable();
            	    _fsp--;
            	    if (failed) return retval;
            	    if ( backtracking==0 ) adaptor.addChild(root_0, variable18.getTree());

            	    }
            	    break;
            	case 6 :
            	    // /VMADL.j/src/de/sm/csimple/CSimple.g:82:67: NEWLINE
            	    {
            	    NEWLINE19=(Token)input.LT(1);
            	    match(input,NEWLINE,FOLLOW_NEWLINE_in_externDef254); if (failed) return retval;
            	    if ( backtracking==0 ) {
            	    NEWLINE19_tree = (Object)adaptor.create(NEWLINE19);
            	    adaptor.addChild(root_0, NEWLINE19_tree);
            	    }

            	    }
            	    break;

            	default :
            	    break loop2;
                }
            } while (true);

            RBRACE20=(Token)input.LT(1);
            match(input,RBRACE,FOLLOW_RBRACE_in_externDef261); if (failed) return retval;
            if ( backtracking==0 ) {
            RBRACE20_tree = (Object)adaptor.create(RBRACE20);
            adaptor.addChild(root_0, RBRACE20_tree);
            }

            }

            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (Object)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end externDef

    public static class literalValue_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start literalValue
    // /VMADL.j/src/de/sm/csimple/CSimple.g:86:0: literalValue : ( IDENTIFIER | ( DIGIT )+ | hexValue | content );
    public final literalValue_return literalValue() throws RecognitionException {
        literalValue_return retval = new literalValue_return();
        retval.start = input.LT(1);

        Object root_0 = null;

        Token IDENTIFIER21=null;
        Token DIGIT22=null;
        hexValue_return hexValue23 = null;

        content_return content24 = null;


        Object IDENTIFIER21_tree=null;
        Object DIGIT22_tree=null;

        try {
            // /VMADL.j/src/de/sm/csimple/CSimple.g:86:13: ( IDENTIFIER | ( DIGIT )+ | hexValue | content )
            int alt4=4;
            switch ( input.LA(1) ) {
            case IDENTIFIER:
                {
                alt4=1;
                }
                break;
            case DIGIT:
                {
                alt4=2;
                }
                break;
            case HEXPREFIX:
                {
                alt4=3;
                }
                break;
            case LBRACE:
                {
                alt4=4;
                }
                break;
            default:
                if (backtracking>0) {failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("86:0: literalValue : ( IDENTIFIER | ( DIGIT )+ | hexValue | content );", 4, 0, input);

                throw nvae;
            }

            switch (alt4) {
                case 1 :
                    // /VMADL.j/src/de/sm/csimple/CSimple.g:87:2: IDENTIFIER
                    {
                    root_0 = (Object)adaptor.nil();

                    IDENTIFIER21=(Token)input.LT(1);
                    match(input,IDENTIFIER,FOLLOW_IDENTIFIER_in_literalValue270); if (failed) return retval;
                    if ( backtracking==0 ) {
                    IDENTIFIER21_tree = (Object)adaptor.create(IDENTIFIER21);
                    adaptor.addChild(root_0, IDENTIFIER21_tree);
                    }

                    }
                    break;
                case 2 :
                    // /VMADL.j/src/de/sm/csimple/CSimple.g:87:15: ( DIGIT )+
                    {
                    root_0 = (Object)adaptor.nil();

                    // /VMADL.j/src/de/sm/csimple/CSimple.g:87:15: ( DIGIT )+
                    int cnt3=0;
                    loop3:
                    do {
                        int alt3=2;
                        int LA3_0 = input.LA(1);

                        if ( (LA3_0==DIGIT) ) {
                            alt3=1;
                        }


                        switch (alt3) {
                    	case 1 :
                    	    // /VMADL.j/src/de/sm/csimple/CSimple.g:0:0: DIGIT
                    	    {
                    	    DIGIT22=(Token)input.LT(1);
                    	    match(input,DIGIT,FOLLOW_DIGIT_in_literalValue274); if (failed) return retval;
                    	    if ( backtracking==0 ) {
                    	    DIGIT22_tree = (Object)adaptor.create(DIGIT22);
                    	    adaptor.addChild(root_0, DIGIT22_tree);
                    	    }

                    	    }
                    	    break;

                    	default :
                    	    if ( cnt3 >= 1 ) break loop3;
                    	    if (backtracking>0) {failed=true; return retval;}
                                EarlyExitException eee =
                                    new EarlyExitException(3, input);
                                throw eee;
                        }
                        cnt3++;
                    } while (true);


                    }
                    break;
                case 3 :
                    // /VMADL.j/src/de/sm/csimple/CSimple.g:87:24: hexValue
                    {
                    root_0 = (Object)adaptor.nil();

                    pushFollow(FOLLOW_hexValue_in_literalValue279);
                    hexValue23=hexValue();
                    _fsp--;
                    if (failed) return retval;
                    if ( backtracking==0 ) adaptor.addChild(root_0, hexValue23.getTree());

                    }
                    break;
                case 4 :
                    // /VMADL.j/src/de/sm/csimple/CSimple.g:87:35: content
                    {
                    root_0 = (Object)adaptor.nil();

                    pushFollow(FOLLOW_content_in_literalValue283);
                    content24=content();
                    _fsp--;
                    if (failed) return retval;
                    if ( backtracking==0 ) adaptor.addChild(root_0, content24.getTree());

                    }
                    break;

            }
            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (Object)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end literalValue

    public static class variable_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start variable
    // /VMADL.j/src/de/sm/csimple/CSimple.g:90:0: variable : ( STATIC | EXTERN )? typeRef IDENTIFIER ( '[' ( literalValue )? ']' )? ( '=' literalValue )? ';' ;
    public final variable_return variable() throws RecognitionException {
        variable_return retval = new variable_return();
        retval.start = input.LT(1);

        Object root_0 = null;

        Token set25=null;
        Token IDENTIFIER27=null;
        Token char_literal28=null;
        Token char_literal30=null;
        Token char_literal31=null;
        Token char_literal33=null;
        typeRef_return typeRef26 = null;

        literalValue_return literalValue29 = null;

        literalValue_return literalValue32 = null;


        Object set25_tree=null;
        Object IDENTIFIER27_tree=null;
        Object char_literal28_tree=null;
        Object char_literal30_tree=null;
        Object char_literal31_tree=null;
        Object char_literal33_tree=null;

        try {
            // /VMADL.j/src/de/sm/csimple/CSimple.g:90:9: ( ( STATIC | EXTERN )? typeRef IDENTIFIER ( '[' ( literalValue )? ']' )? ( '=' literalValue )? ';' )
            // /VMADL.j/src/de/sm/csimple/CSimple.g:91:2: ( STATIC | EXTERN )? typeRef IDENTIFIER ( '[' ( literalValue )? ']' )? ( '=' literalValue )? ';'
            {
            root_0 = (Object)adaptor.nil();

            // /VMADL.j/src/de/sm/csimple/CSimple.g:91:2: ( STATIC | EXTERN )?
            int alt5=2;
            int LA5_0 = input.LA(1);

            if ( (LA5_0==STATIC||LA5_0==EXTERN) ) {
                alt5=1;
            }
            switch (alt5) {
                case 1 :
                    // /VMADL.j/src/de/sm/csimple/CSimple.g:
                    {
                    set25=(Token)input.LT(1);
                    if ( input.LA(1)==STATIC||input.LA(1)==EXTERN ) {
                        input.consume();
                        if ( backtracking==0 ) adaptor.addChild(root_0, adaptor.create(set25));
                        errorRecovery=false;failed=false;
                    }
                    else {
                        if (backtracking>0) {failed=true; return retval;}
                        MismatchedSetException mse =
                            new MismatchedSetException(null,input);
                        recoverFromMismatchedSet(input,mse,FOLLOW_set_in_variable292);    throw mse;
                    }


                    }
                    break;

            }

            pushFollow(FOLLOW_typeRef_in_variable302);
            typeRef26=typeRef();
            _fsp--;
            if (failed) return retval;
            if ( backtracking==0 ) adaptor.addChild(root_0, typeRef26.getTree());
            IDENTIFIER27=(Token)input.LT(1);
            match(input,IDENTIFIER,FOLLOW_IDENTIFIER_in_variable307); if (failed) return retval;
            if ( backtracking==0 ) {
            IDENTIFIER27_tree = (Object)adaptor.create(IDENTIFIER27);
            adaptor.addChild(root_0, IDENTIFIER27_tree);
            }
            // /VMADL.j/src/de/sm/csimple/CSimple.g:94:2: ( '[' ( literalValue )? ']' )?
            int alt7=2;
            int LA7_0 = input.LA(1);

            if ( (LA7_0==24) ) {
                alt7=1;
            }
            switch (alt7) {
                case 1 :
                    // /VMADL.j/src/de/sm/csimple/CSimple.g:94:3: '[' ( literalValue )? ']'
                    {
                    char_literal28=(Token)input.LT(1);
                    match(input,24,FOLLOW_24_in_variable312); if (failed) return retval;
                    if ( backtracking==0 ) {
                    char_literal28_tree = (Object)adaptor.create(char_literal28);
                    adaptor.addChild(root_0, char_literal28_tree);
                    }
                    // /VMADL.j/src/de/sm/csimple/CSimple.g:94:7: ( literalValue )?
                    int alt6=2;
                    int LA6_0 = input.LA(1);

                    if ( (LA6_0==HEXPREFIX||(LA6_0>=IDENTIFIER && LA6_0<=LBRACE)||LA6_0==DIGIT) ) {
                        alt6=1;
                    }
                    switch (alt6) {
                        case 1 :
                            // /VMADL.j/src/de/sm/csimple/CSimple.g:94:8: literalValue
                            {
                            pushFollow(FOLLOW_literalValue_in_variable315);
                            literalValue29=literalValue();
                            _fsp--;
                            if (failed) return retval;
                            if ( backtracking==0 ) adaptor.addChild(root_0, literalValue29.getTree());

                            }
                            break;

                    }

                    char_literal30=(Token)input.LT(1);
                    match(input,25,FOLLOW_25_in_variable319); if (failed) return retval;
                    if ( backtracking==0 ) {
                    char_literal30_tree = (Object)adaptor.create(char_literal30);
                    adaptor.addChild(root_0, char_literal30_tree);
                    }

                    }
                    break;

            }

            // /VMADL.j/src/de/sm/csimple/CSimple.g:95:2: ( '=' literalValue )?
            int alt8=2;
            int LA8_0 = input.LA(1);

            if ( (LA8_0==26) ) {
                alt8=1;
            }
            switch (alt8) {
                case 1 :
                    // /VMADL.j/src/de/sm/csimple/CSimple.g:95:4: '=' literalValue
                    {
                    char_literal31=(Token)input.LT(1);
                    match(input,26,FOLLOW_26_in_variable326); if (failed) return retval;
                    if ( backtracking==0 ) {
                    char_literal31_tree = (Object)adaptor.create(char_literal31);
                    adaptor.addChild(root_0, char_literal31_tree);
                    }
                    pushFollow(FOLLOW_literalValue_in_variable328);
                    literalValue32=literalValue();
                    _fsp--;
                    if (failed) return retval;
                    if ( backtracking==0 ) adaptor.addChild(root_0, literalValue32.getTree());

                    }
                    break;

            }

            char_literal33=(Token)input.LT(1);
            match(input,27,FOLLOW_27_in_variable334); if (failed) return retval;
            if ( backtracking==0 ) {
            char_literal33_tree = (Object)adaptor.create(char_literal33);
            adaptor.addChild(root_0, char_literal33_tree);
            }

            }

            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (Object)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end variable

    public static class preprocessor_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start preprocessor
    // /VMADL.j/src/de/sm/csimple/CSimple.g:99:0: preprocessor : '#' ( (~ ( PPCONTINUE | NEWLINE ) )* PPCONTINUE )* (~ ( PPCONTINUE | NEWLINE ) )* NEWLINE ;
    public final preprocessor_return preprocessor() throws RecognitionException {
        preprocessor_return retval = new preprocessor_return();
        retval.start = input.LT(1);

        Object root_0 = null;

        Token char_literal34=null;
        Token set35=null;
        Token PPCONTINUE36=null;
        Token set37=null;
        Token NEWLINE38=null;

        Object char_literal34_tree=null;
        Object set35_tree=null;
        Object PPCONTINUE36_tree=null;
        Object set37_tree=null;
        Object NEWLINE38_tree=null;

        try {
            // /VMADL.j/src/de/sm/csimple/CSimple.g:99:14: ( '#' ( (~ ( PPCONTINUE | NEWLINE ) )* PPCONTINUE )* (~ ( PPCONTINUE | NEWLINE ) )* NEWLINE )
            // /VMADL.j/src/de/sm/csimple/CSimple.g:100:3: '#' ( (~ ( PPCONTINUE | NEWLINE ) )* PPCONTINUE )* (~ ( PPCONTINUE | NEWLINE ) )* NEWLINE
            {
            root_0 = (Object)adaptor.nil();

            char_literal34=(Token)input.LT(1);
            match(input,28,FOLLOW_28_in_preprocessor345); if (failed) return retval;
            if ( backtracking==0 ) {
            char_literal34_tree = (Object)adaptor.create(char_literal34);
            adaptor.addChild(root_0, char_literal34_tree);
            }
            // /VMADL.j/src/de/sm/csimple/CSimple.g:101:3: ( (~ ( PPCONTINUE | NEWLINE ) )* PPCONTINUE )*
            loop10:
            do {
                int alt10=2;
                alt10 = dfa10.predict(input);
                switch (alt10) {
            	case 1 :
            	    // /VMADL.j/src/de/sm/csimple/CSimple.g:101:4: (~ ( PPCONTINUE | NEWLINE ) )* PPCONTINUE
            	    {
            	    // /VMADL.j/src/de/sm/csimple/CSimple.g:101:4: (~ ( PPCONTINUE | NEWLINE ) )*
            	    loop9:
            	    do {
            	        int alt9=2;
            	        int LA9_0 = input.LA(1);

            	        if ( ((LA9_0>=TYPEDEF && LA9_0<=HEXPREFIX)||(LA9_0>=QUOTE && LA9_0<=DIGIT)||(LA9_0>=SPECIAL && LA9_0<=35)) ) {
            	            alt9=1;
            	        }


            	        switch (alt9) {
            	    	case 1 :
            	    	    // /VMADL.j/src/de/sm/csimple/CSimple.g:101:5: ~ ( PPCONTINUE | NEWLINE )
            	    	    {
            	    	    set35=(Token)input.LT(1);
            	    	    if ( (input.LA(1)>=TYPEDEF && input.LA(1)<=HEXPREFIX)||(input.LA(1)>=QUOTE && input.LA(1)<=DIGIT)||(input.LA(1)>=SPECIAL && input.LA(1)<=35) ) {
            	    	        input.consume();
            	    	        if ( backtracking==0 ) adaptor.addChild(root_0, adaptor.create(set35));
            	    	        errorRecovery=false;failed=false;
            	    	    }
            	    	    else {
            	    	        if (backtracking>0) {failed=true; return retval;}
            	    	        MismatchedSetException mse =
            	    	            new MismatchedSetException(null,input);
            	    	        recoverFromMismatchedSet(input,mse,FOLLOW_set_in_preprocessor351);    throw mse;
            	    	    }


            	    	    }
            	    	    break;

            	    	default :
            	    	    break loop9;
            	        }
            	    } while (true);

            	    PPCONTINUE36=(Token)input.LT(1);
            	    match(input,PPCONTINUE,FOLLOW_PPCONTINUE_in_preprocessor364); if (failed) return retval;
            	    if ( backtracking==0 ) {
            	    PPCONTINUE36_tree = (Object)adaptor.create(PPCONTINUE36);
            	    adaptor.addChild(root_0, PPCONTINUE36_tree);
            	    }

            	    }
            	    break;

            	default :
            	    break loop10;
                }
            } while (true);

            // /VMADL.j/src/de/sm/csimple/CSimple.g:102:3: (~ ( PPCONTINUE | NEWLINE ) )*
            loop11:
            do {
                int alt11=2;
                int LA11_0 = input.LA(1);

                if ( ((LA11_0>=TYPEDEF && LA11_0<=HEXPREFIX)||(LA11_0>=QUOTE && LA11_0<=DIGIT)||(LA11_0>=SPECIAL && LA11_0<=35)) ) {
                    alt11=1;
                }


                switch (alt11) {
            	case 1 :
            	    // /VMADL.j/src/de/sm/csimple/CSimple.g:102:4: ~ ( PPCONTINUE | NEWLINE )
            	    {
            	    set37=(Token)input.LT(1);
            	    if ( (input.LA(1)>=TYPEDEF && input.LA(1)<=HEXPREFIX)||(input.LA(1)>=QUOTE && input.LA(1)<=DIGIT)||(input.LA(1)>=SPECIAL && input.LA(1)<=35) ) {
            	        input.consume();
            	        if ( backtracking==0 ) adaptor.addChild(root_0, adaptor.create(set37));
            	        errorRecovery=false;failed=false;
            	    }
            	    else {
            	        if (backtracking>0) {failed=true; return retval;}
            	        MismatchedSetException mse =
            	            new MismatchedSetException(null,input);
            	        recoverFromMismatchedSet(input,mse,FOLLOW_set_in_preprocessor371);    throw mse;
            	    }


            	    }
            	    break;

            	default :
            	    break loop11;
                }
            } while (true);

            NEWLINE38=(Token)input.LT(1);
            match(input,NEWLINE,FOLLOW_NEWLINE_in_preprocessor389); if (failed) return retval;
            if ( backtracking==0 ) {
            NEWLINE38_tree = (Object)adaptor.create(NEWLINE38);
            adaptor.addChild(root_0, NEWLINE38_tree);
            }

            }

            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (Object)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end preprocessor

    public static class typedefinition_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start typedefinition
    // /VMADL.j/src/de/sm/csimple/CSimple.g:107:0: typedefinition : TYPEDEF def ;
    public final typedefinition_return typedefinition() throws RecognitionException {
        typedefinition_return retval = new typedefinition_return();
        retval.start = input.LT(1);

        Object root_0 = null;

        Token TYPEDEF39=null;
        def_return def40 = null;


        Object TYPEDEF39_tree=null;

        try {
            // /VMADL.j/src/de/sm/csimple/CSimple.g:107:15: ( TYPEDEF def )
            // /VMADL.j/src/de/sm/csimple/CSimple.g:108:2: TYPEDEF def
            {
            root_0 = (Object)adaptor.nil();

            TYPEDEF39=(Token)input.LT(1);
            match(input,TYPEDEF,FOLLOW_TYPEDEF_in_typedefinition400); if (failed) return retval;
            if ( backtracking==0 ) {
            TYPEDEF39_tree = (Object)adaptor.create(TYPEDEF39);
            adaptor.addChild(root_0, TYPEDEF39_tree);
            }
            pushFollow(FOLLOW_def_in_typedefinition402);
            def40=def();
            _fsp--;
            if (failed) return retval;
            if ( backtracking==0 ) adaptor.addChild(root_0, def40.getTree());

            }

            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (Object)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end typedefinition

    public static class struct_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start struct
    // /VMADL.j/src/de/sm/csimple/CSimple.g:111:0: struct : ( STRUCT def | ( IDENTIFIER '(' IDENTIFIER ')' content ';' ) );
    public final struct_return struct() throws RecognitionException {
        struct_return retval = new struct_return();
        retval.start = input.LT(1);

        Object root_0 = null;

        Token STRUCT41=null;
        Token IDENTIFIER43=null;
        Token char_literal44=null;
        Token IDENTIFIER45=null;
        Token char_literal46=null;
        Token char_literal48=null;
        def_return def42 = null;

        content_return content47 = null;


        Object STRUCT41_tree=null;
        Object IDENTIFIER43_tree=null;
        Object char_literal44_tree=null;
        Object IDENTIFIER45_tree=null;
        Object char_literal46_tree=null;
        Object char_literal48_tree=null;

        try {
            // /VMADL.j/src/de/sm/csimple/CSimple.g:111:7: ( STRUCT def | ( IDENTIFIER '(' IDENTIFIER ')' content ';' ) )
            int alt12=2;
            int LA12_0 = input.LA(1);

            if ( (LA12_0==STRUCT) ) {
                alt12=1;
            }
            else if ( (LA12_0==IDENTIFIER) ) {
                alt12=2;
            }
            else {
                if (backtracking>0) {failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("111:0: struct : ( STRUCT def | ( IDENTIFIER '(' IDENTIFIER ')' content ';' ) );", 12, 0, input);

                throw nvae;
            }
            switch (alt12) {
                case 1 :
                    // /VMADL.j/src/de/sm/csimple/CSimple.g:112:2: STRUCT def
                    {
                    root_0 = (Object)adaptor.nil();

                    STRUCT41=(Token)input.LT(1);
                    match(input,STRUCT,FOLLOW_STRUCT_in_struct411); if (failed) return retval;
                    if ( backtracking==0 ) {
                    STRUCT41_tree = (Object)adaptor.create(STRUCT41);
                    adaptor.addChild(root_0, STRUCT41_tree);
                    }
                    pushFollow(FOLLOW_def_in_struct413);
                    def42=def();
                    _fsp--;
                    if (failed) return retval;
                    if ( backtracking==0 ) adaptor.addChild(root_0, def42.getTree());

                    }
                    break;
                case 2 :
                    // /VMADL.j/src/de/sm/csimple/CSimple.g:113:4: ( IDENTIFIER '(' IDENTIFIER ')' content ';' )
                    {
                    root_0 = (Object)adaptor.nil();

                    // /VMADL.j/src/de/sm/csimple/CSimple.g:113:4: ( IDENTIFIER '(' IDENTIFIER ')' content ';' )
                    // /VMADL.j/src/de/sm/csimple/CSimple.g:113:5: IDENTIFIER '(' IDENTIFIER ')' content ';'
                    {
                    IDENTIFIER43=(Token)input.LT(1);
                    match(input,IDENTIFIER,FOLLOW_IDENTIFIER_in_struct419); if (failed) return retval;
                    if ( backtracking==0 ) {
                    IDENTIFIER43_tree = (Object)adaptor.create(IDENTIFIER43);
                    adaptor.addChild(root_0, IDENTIFIER43_tree);
                    }
                    char_literal44=(Token)input.LT(1);
                    match(input,29,FOLLOW_29_in_struct421); if (failed) return retval;
                    if ( backtracking==0 ) {
                    char_literal44_tree = (Object)adaptor.create(char_literal44);
                    adaptor.addChild(root_0, char_literal44_tree);
                    }
                    IDENTIFIER45=(Token)input.LT(1);
                    match(input,IDENTIFIER,FOLLOW_IDENTIFIER_in_struct423); if (failed) return retval;
                    if ( backtracking==0 ) {
                    IDENTIFIER45_tree = (Object)adaptor.create(IDENTIFIER45);
                    adaptor.addChild(root_0, IDENTIFIER45_tree);
                    }
                    char_literal46=(Token)input.LT(1);
                    match(input,30,FOLLOW_30_in_struct425); if (failed) return retval;
                    if ( backtracking==0 ) {
                    char_literal46_tree = (Object)adaptor.create(char_literal46);
                    adaptor.addChild(root_0, char_literal46_tree);
                    }
                    pushFollow(FOLLOW_content_in_struct427);
                    content47=content();
                    _fsp--;
                    if (failed) return retval;
                    if ( backtracking==0 ) adaptor.addChild(root_0, content47.getTree());
                    char_literal48=(Token)input.LT(1);
                    match(input,27,FOLLOW_27_in_struct429); if (failed) return retval;
                    if ( backtracking==0 ) {
                    char_literal48_tree = (Object)adaptor.create(char_literal48);
                    adaptor.addChild(root_0, char_literal48_tree);
                    }

                    }


                    }
                    break;

            }
            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (Object)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end struct

    public static class def_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start def
    // /VMADL.j/src/de/sm/csimple/CSimple.g:116:0: def : ( content | ~ ( ';' | LBRACE ) )* ';' ;
    public final def_return def() throws RecognitionException {
        def_return retval = new def_return();
        retval.start = input.LT(1);

        Object root_0 = null;

        Token set50=null;
        Token char_literal51=null;
        content_return content49 = null;


        Object set50_tree=null;
        Object char_literal51_tree=null;

        try {
            // /VMADL.j/src/de/sm/csimple/CSimple.g:116:4: ( ( content | ~ ( ';' | LBRACE ) )* ';' )
            // /VMADL.j/src/de/sm/csimple/CSimple.g:117:2: ( content | ~ ( ';' | LBRACE ) )* ';'
            {
            root_0 = (Object)adaptor.nil();

            // /VMADL.j/src/de/sm/csimple/CSimple.g:117:2: ( content | ~ ( ';' | LBRACE ) )*
            loop13:
            do {
                int alt13=3;
                int LA13_0 = input.LA(1);

                if ( (LA13_0==LBRACE) ) {
                    alt13=1;
                }
                else if ( ((LA13_0>=TYPEDEF && LA13_0<=IDENTIFIER)||(LA13_0>=RBRACE && LA13_0<=26)||(LA13_0>=28 && LA13_0<=35)) ) {
                    alt13=2;
                }


                switch (alt13) {
            	case 1 :
            	    // /VMADL.j/src/de/sm/csimple/CSimple.g:117:3: content
            	    {
            	    pushFollow(FOLLOW_content_in_def441);
            	    content49=content();
            	    _fsp--;
            	    if (failed) return retval;
            	    if ( backtracking==0 ) adaptor.addChild(root_0, content49.getTree());

            	    }
            	    break;
            	case 2 :
            	    // /VMADL.j/src/de/sm/csimple/CSimple.g:117:13: ~ ( ';' | LBRACE )
            	    {
            	    set50=(Token)input.LT(1);
            	    if ( (input.LA(1)>=TYPEDEF && input.LA(1)<=IDENTIFIER)||(input.LA(1)>=RBRACE && input.LA(1)<=26)||(input.LA(1)>=28 && input.LA(1)<=35) ) {
            	        input.consume();
            	        if ( backtracking==0 ) adaptor.addChild(root_0, adaptor.create(set50));
            	        errorRecovery=false;failed=false;
            	    }
            	    else {
            	        if (backtracking>0) {failed=true; return retval;}
            	        MismatchedSetException mse =
            	            new MismatchedSetException(null,input);
            	        recoverFromMismatchedSet(input,mse,FOLLOW_set_in_def445);    throw mse;
            	    }


            	    }
            	    break;

            	default :
            	    break loop13;
                }
            } while (true);

            char_literal51=(Token)input.LT(1);
            match(input,27,FOLLOW_27_in_def457); if (failed) return retval;
            if ( backtracking==0 ) {
            char_literal51_tree = (Object)adaptor.create(char_literal51);
            adaptor.addChild(root_0, char_literal51_tree);
            }

            }

            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (Object)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end def

    public static class function_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start function
    // /VMADL.j/src/de/sm/csimple/CSimple.g:121:0: function : ( STATIC | EXTERN )? ( INLINE )? returnType= typeRef name= typeRef '(' (~ ( ')' ) )* ')' ( content | ( ATTR '(' '(' IDENTIFIER ')' ')' )? ';' ) ;
    public final function_return function() throws RecognitionException {
        function_return retval = new function_return();
        retval.start = input.LT(1);

        Object root_0 = null;

        Token set52=null;
        Token INLINE53=null;
        Token char_literal54=null;
        Token set55=null;
        Token char_literal56=null;
        Token ATTR58=null;
        Token char_literal59=null;
        Token char_literal60=null;
        Token IDENTIFIER61=null;
        Token char_literal62=null;
        Token char_literal63=null;
        Token char_literal64=null;
        typeRef_return returnType = null;

        typeRef_return name = null;

        content_return content57 = null;


        Object set52_tree=null;
        Object INLINE53_tree=null;
        Object char_literal54_tree=null;
        Object set55_tree=null;
        Object char_literal56_tree=null;
        Object ATTR58_tree=null;
        Object char_literal59_tree=null;
        Object char_literal60_tree=null;
        Object IDENTIFIER61_tree=null;
        Object char_literal62_tree=null;
        Object char_literal63_tree=null;
        Object char_literal64_tree=null;

        try {
            // /VMADL.j/src/de/sm/csimple/CSimple.g:121:9: ( ( STATIC | EXTERN )? ( INLINE )? returnType= typeRef name= typeRef '(' (~ ( ')' ) )* ')' ( content | ( ATTR '(' '(' IDENTIFIER ')' ')' )? ';' ) )
            // /VMADL.j/src/de/sm/csimple/CSimple.g:122:2: ( STATIC | EXTERN )? ( INLINE )? returnType= typeRef name= typeRef '(' (~ ( ')' ) )* ')' ( content | ( ATTR '(' '(' IDENTIFIER ')' ')' )? ';' )
            {
            root_0 = (Object)adaptor.nil();

            // /VMADL.j/src/de/sm/csimple/CSimple.g:122:2: ( STATIC | EXTERN )?
            int alt14=2;
            int LA14_0 = input.LA(1);

            if ( (LA14_0==STATIC||LA14_0==EXTERN) ) {
                alt14=1;
            }
            switch (alt14) {
                case 1 :
                    // /VMADL.j/src/de/sm/csimple/CSimple.g:
                    {
                    set52=(Token)input.LT(1);
                    if ( input.LA(1)==STATIC||input.LA(1)==EXTERN ) {
                        input.consume();
                        if ( backtracking==0 ) adaptor.addChild(root_0, adaptor.create(set52));
                        errorRecovery=false;failed=false;
                    }
                    else {
                        if (backtracking>0) {failed=true; return retval;}
                        MismatchedSetException mse =
                            new MismatchedSetException(null,input);
                        recoverFromMismatchedSet(input,mse,FOLLOW_set_in_function466);    throw mse;
                    }


                    }
                    break;

            }

            // /VMADL.j/src/de/sm/csimple/CSimple.g:122:21: ( INLINE )?
            int alt15=2;
            int LA15_0 = input.LA(1);

            if ( (LA15_0==INLINE) ) {
                alt15=1;
            }
            switch (alt15) {
                case 1 :
                    // /VMADL.j/src/de/sm/csimple/CSimple.g:122:22: INLINE
                    {
                    INLINE53=(Token)input.LT(1);
                    match(input,INLINE,FOLLOW_INLINE_in_function476); if (failed) return retval;
                    if ( backtracking==0 ) {
                    INLINE53_tree = (Object)adaptor.create(INLINE53);
                    adaptor.addChild(root_0, INLINE53_tree);
                    }

                    }
                    break;

            }

            pushFollow(FOLLOW_typeRef_in_function483);
            returnType=typeRef();
            _fsp--;
            if (failed) return retval;
            if ( backtracking==0 ) adaptor.addChild(root_0, returnType.getTree());
            pushFollow(FOLLOW_typeRef_in_function487);
            name=typeRef();
            _fsp--;
            if (failed) return retval;
            if ( backtracking==0 ) adaptor.addChild(root_0, name.getTree());
            char_literal54=(Token)input.LT(1);
            match(input,29,FOLLOW_29_in_function489); if (failed) return retval;
            if ( backtracking==0 ) {
            char_literal54_tree = (Object)adaptor.create(char_literal54);
            adaptor.addChild(root_0, char_literal54_tree);
            }
            // /VMADL.j/src/de/sm/csimple/CSimple.g:123:38: (~ ( ')' ) )*
            loop16:
            do {
                int alt16=2;
                int LA16_0 = input.LA(1);

                if ( ((LA16_0>=TYPEDEF && LA16_0<=29)||(LA16_0>=31 && LA16_0<=35)) ) {
                    alt16=1;
                }


                switch (alt16) {
            	case 1 :
            	    // /VMADL.j/src/de/sm/csimple/CSimple.g:0:0: ~ ( ')' )
            	    {
            	    set55=(Token)input.LT(1);
            	    if ( (input.LA(1)>=TYPEDEF && input.LA(1)<=29)||(input.LA(1)>=31 && input.LA(1)<=35) ) {
            	        input.consume();
            	        if ( backtracking==0 ) adaptor.addChild(root_0, adaptor.create(set55));
            	        errorRecovery=false;failed=false;
            	    }
            	    else {
            	        if (backtracking>0) {failed=true; return retval;}
            	        MismatchedSetException mse =
            	            new MismatchedSetException(null,input);
            	        recoverFromMismatchedSet(input,mse,FOLLOW_set_in_function491);    throw mse;
            	    }


            	    }
            	    break;

            	default :
            	    break loop16;
                }
            } while (true);

            char_literal56=(Token)input.LT(1);
            match(input,30,FOLLOW_30_in_function497); if (failed) return retval;
            if ( backtracking==0 ) {
            char_literal56_tree = (Object)adaptor.create(char_literal56);
            adaptor.addChild(root_0, char_literal56_tree);
            }
            // /VMADL.j/src/de/sm/csimple/CSimple.g:124:2: ( content | ( ATTR '(' '(' IDENTIFIER ')' ')' )? ';' )
            int alt18=2;
            int LA18_0 = input.LA(1);

            if ( (LA18_0==LBRACE) ) {
                alt18=1;
            }
            else if ( (LA18_0==ATTR||LA18_0==27) ) {
                alt18=2;
            }
            else {
                if (backtracking>0) {failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("124:2: ( content | ( ATTR '(' '(' IDENTIFIER ')' ')' )? ';' )", 18, 0, input);

                throw nvae;
            }
            switch (alt18) {
                case 1 :
                    // /VMADL.j/src/de/sm/csimple/CSimple.g:124:3: content
                    {
                    pushFollow(FOLLOW_content_in_function501);
                    content57=content();
                    _fsp--;
                    if (failed) return retval;
                    if ( backtracking==0 ) adaptor.addChild(root_0, content57.getTree());

                    }
                    break;
                case 2 :
                    // /VMADL.j/src/de/sm/csimple/CSimple.g:125:5: ( ATTR '(' '(' IDENTIFIER ')' ')' )? ';'
                    {
                    // /VMADL.j/src/de/sm/csimple/CSimple.g:125:5: ( ATTR '(' '(' IDENTIFIER ')' ')' )?
                    int alt17=2;
                    int LA17_0 = input.LA(1);

                    if ( (LA17_0==ATTR) ) {
                        alt17=1;
                    }
                    switch (alt17) {
                        case 1 :
                            // /VMADL.j/src/de/sm/csimple/CSimple.g:125:6: ATTR '(' '(' IDENTIFIER ')' ')'
                            {
                            ATTR58=(Token)input.LT(1);
                            match(input,ATTR,FOLLOW_ATTR_in_function509); if (failed) return retval;
                            if ( backtracking==0 ) {
                            ATTR58_tree = (Object)adaptor.create(ATTR58);
                            adaptor.addChild(root_0, ATTR58_tree);
                            }
                            char_literal59=(Token)input.LT(1);
                            match(input,29,FOLLOW_29_in_function511); if (failed) return retval;
                            if ( backtracking==0 ) {
                            char_literal59_tree = (Object)adaptor.create(char_literal59);
                            adaptor.addChild(root_0, char_literal59_tree);
                            }
                            char_literal60=(Token)input.LT(1);
                            match(input,29,FOLLOW_29_in_function513); if (failed) return retval;
                            if ( backtracking==0 ) {
                            char_literal60_tree = (Object)adaptor.create(char_literal60);
                            adaptor.addChild(root_0, char_literal60_tree);
                            }
                            IDENTIFIER61=(Token)input.LT(1);
                            match(input,IDENTIFIER,FOLLOW_IDENTIFIER_in_function515); if (failed) return retval;
                            if ( backtracking==0 ) {
                            IDENTIFIER61_tree = (Object)adaptor.create(IDENTIFIER61);
                            adaptor.addChild(root_0, IDENTIFIER61_tree);
                            }
                            char_literal62=(Token)input.LT(1);
                            match(input,30,FOLLOW_30_in_function517); if (failed) return retval;
                            if ( backtracking==0 ) {
                            char_literal62_tree = (Object)adaptor.create(char_literal62);
                            adaptor.addChild(root_0, char_literal62_tree);
                            }
                            char_literal63=(Token)input.LT(1);
                            match(input,30,FOLLOW_30_in_function519); if (failed) return retval;
                            if ( backtracking==0 ) {
                            char_literal63_tree = (Object)adaptor.create(char_literal63);
                            adaptor.addChild(root_0, char_literal63_tree);
                            }

                            }
                            break;

                    }

                    char_literal64=(Token)input.LT(1);
                    match(input,27,FOLLOW_27_in_function527); if (failed) return retval;
                    if ( backtracking==0 ) {
                    char_literal64_tree = (Object)adaptor.create(char_literal64);
                    adaptor.addChild(root_0, char_literal64_tree);
                    }

                    }
                    break;

            }

            if ( backtracking==0 ) {
              	functions.add(input.toString(name.start,name.stop).intern());	
            }

            }

            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (Object)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end function

    public static class contentcontent_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start contentcontent
    // /VMADL.j/src/de/sm/csimple/CSimple.g:131:0: contentcontent : ( content | (~ ( LBRACE | RBRACE ) )+ )* ;
    public final contentcontent_return contentcontent() throws RecognitionException {
        contentcontent_return retval = new contentcontent_return();
        retval.start = input.LT(1);

        Object root_0 = null;

        Token set66=null;
        content_return content65 = null;


        Object set66_tree=null;

        try {
            // /VMADL.j/src/de/sm/csimple/CSimple.g:131:15: ( ( content | (~ ( LBRACE | RBRACE ) )+ )* )
            // /VMADL.j/src/de/sm/csimple/CSimple.g:132:2: ( content | (~ ( LBRACE | RBRACE ) )+ )*
            {
            root_0 = (Object)adaptor.nil();

            // /VMADL.j/src/de/sm/csimple/CSimple.g:132:2: ( content | (~ ( LBRACE | RBRACE ) )+ )*
            loop20:
            do {
                int alt20=3;
                int LA20_0 = input.LA(1);

                if ( (LA20_0==LBRACE) ) {
                    alt20=1;
                }
                else if ( ((LA20_0>=TYPEDEF && LA20_0<=IDENTIFIER)||(LA20_0>=DIGIT && LA20_0<=35)) ) {
                    alt20=2;
                }


                switch (alt20) {
            	case 1 :
            	    // /VMADL.j/src/de/sm/csimple/CSimple.g:132:3: content
            	    {
            	    pushFollow(FOLLOW_content_in_contentcontent543);
            	    content65=content();
            	    _fsp--;
            	    if (failed) return retval;
            	    if ( backtracking==0 ) adaptor.addChild(root_0, content65.getTree());

            	    }
            	    break;
            	case 2 :
            	    // /VMADL.j/src/de/sm/csimple/CSimple.g:132:13: (~ ( LBRACE | RBRACE ) )+
            	    {
            	    // /VMADL.j/src/de/sm/csimple/CSimple.g:132:13: (~ ( LBRACE | RBRACE ) )+
            	    int cnt19=0;
            	    loop19:
            	    do {
            	        int alt19=2;
            	        int LA19_0 = input.LA(1);

            	        if ( ((LA19_0>=TYPEDEF && LA19_0<=IDENTIFIER)||(LA19_0>=DIGIT && LA19_0<=35)) ) {
            	            int LA19_2 = input.LA(2);

            	            if ( (synpred41()) ) {
            	                alt19=1;
            	            }


            	        }


            	        switch (alt19) {
            	    	case 1 :
            	    	    // /VMADL.j/src/de/sm/csimple/CSimple.g:132:14: ~ ( LBRACE | RBRACE )
            	    	    {
            	    	    set66=(Token)input.LT(1);
            	    	    if ( (input.LA(1)>=TYPEDEF && input.LA(1)<=IDENTIFIER)||(input.LA(1)>=DIGIT && input.LA(1)<=35) ) {
            	    	        input.consume();
            	    	        if ( backtracking==0 ) adaptor.addChild(root_0, adaptor.create(set66));
            	    	        errorRecovery=false;failed=false;
            	    	    }
            	    	    else {
            	    	        if (backtracking>0) {failed=true; return retval;}
            	    	        MismatchedSetException mse =
            	    	            new MismatchedSetException(null,input);
            	    	        recoverFromMismatchedSet(input,mse,FOLLOW_set_in_contentcontent548);    throw mse;
            	    	    }


            	    	    }
            	    	    break;

            	    	default :
            	    	    if ( cnt19 >= 1 ) break loop19;
            	    	    if (backtracking>0) {failed=true; return retval;}
            	                EarlyExitException eee =
            	                    new EarlyExitException(19, input);
            	                throw eee;
            	        }
            	        cnt19++;
            	    } while (true);


            	    }
            	    break;

            	default :
            	    break loop20;
                }
            } while (true);


            }

            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (Object)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end contentcontent

    public static class content_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start content
    // /VMADL.j/src/de/sm/csimple/CSimple.g:134:0: content : LBRACE contentcontent RBRACE ;
    public final content_return content() throws RecognitionException {
        content_return retval = new content_return();
        retval.start = input.LT(1);

        Object root_0 = null;

        Token LBRACE67=null;
        Token RBRACE69=null;
        contentcontent_return contentcontent68 = null;


        Object LBRACE67_tree=null;
        Object RBRACE69_tree=null;

        try {
            // /VMADL.j/src/de/sm/csimple/CSimple.g:134:9: ( LBRACE contentcontent RBRACE )
            // /VMADL.j/src/de/sm/csimple/CSimple.g:135:3: LBRACE contentcontent RBRACE
            {
            root_0 = (Object)adaptor.nil();

            LBRACE67=(Token)input.LT(1);
            match(input,LBRACE,FOLLOW_LBRACE_in_content569); if (failed) return retval;
            if ( backtracking==0 ) {
            LBRACE67_tree = (Object)adaptor.create(LBRACE67);
            adaptor.addChild(root_0, LBRACE67_tree);
            }
            pushFollow(FOLLOW_contentcontent_in_content571);
            contentcontent68=contentcontent();
            _fsp--;
            if (failed) return retval;
            if ( backtracking==0 ) adaptor.addChild(root_0, contentcontent68.getTree());
            RBRACE69=(Token)input.LT(1);
            match(input,RBRACE,FOLLOW_RBRACE_in_content573); if (failed) return retval;
            if ( backtracking==0 ) {
            RBRACE69_tree = (Object)adaptor.create(RBRACE69);
            adaptor.addChild(root_0, RBRACE69_tree);
            }

            }

            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (Object)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end content

    public static class typeRef_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start typeRef
    // /VMADL.j/src/de/sm/csimple/CSimple.g:138:0: typeRef : ( CONST )? ( IDENTIFIER | IDENTIFIER '(' IDENTIFIER ')' ) ( '*' )* ;
    public final typeRef_return typeRef() throws RecognitionException {
        typeRef_return retval = new typeRef_return();
        retval.start = input.LT(1);

        Object root_0 = null;

        Token CONST70=null;
        Token IDENTIFIER71=null;
        Token IDENTIFIER72=null;
        Token char_literal73=null;
        Token IDENTIFIER74=null;
        Token char_literal75=null;
        Token char_literal76=null;

        Object CONST70_tree=null;
        Object IDENTIFIER71_tree=null;
        Object IDENTIFIER72_tree=null;
        Object char_literal73_tree=null;
        Object IDENTIFIER74_tree=null;
        Object char_literal75_tree=null;
        Object char_literal76_tree=null;

        try {
            // /VMADL.j/src/de/sm/csimple/CSimple.g:138:8: ( ( CONST )? ( IDENTIFIER | IDENTIFIER '(' IDENTIFIER ')' ) ( '*' )* )
            // /VMADL.j/src/de/sm/csimple/CSimple.g:139:2: ( CONST )? ( IDENTIFIER | IDENTIFIER '(' IDENTIFIER ')' ) ( '*' )*
            {
            root_0 = (Object)adaptor.nil();

            // /VMADL.j/src/de/sm/csimple/CSimple.g:139:2: ( CONST )?
            int alt21=2;
            int LA21_0 = input.LA(1);

            if ( (LA21_0==CONST) ) {
                alt21=1;
            }
            switch (alt21) {
                case 1 :
                    // /VMADL.j/src/de/sm/csimple/CSimple.g:0:0: CONST
                    {
                    CONST70=(Token)input.LT(1);
                    match(input,CONST,FOLLOW_CONST_in_typeRef582); if (failed) return retval;
                    if ( backtracking==0 ) {
                    CONST70_tree = (Object)adaptor.create(CONST70);
                    adaptor.addChild(root_0, CONST70_tree);
                    }

                    }
                    break;

            }

            // /VMADL.j/src/de/sm/csimple/CSimple.g:140:2: ( IDENTIFIER | IDENTIFIER '(' IDENTIFIER ')' )
            int alt22=2;
            int LA22_0 = input.LA(1);

            if ( (LA22_0==IDENTIFIER) ) {
                int LA22_1 = input.LA(2);

                if ( (LA22_1==29) ) {
                    int LA22_2 = input.LA(3);

                    if ( (LA22_2==IDENTIFIER) ) {
                        int LA22_4 = input.LA(4);

                        if ( (LA22_4==30) ) {
                            int LA22_5 = input.LA(5);

                            if ( (LA22_5==ATTR||LA22_5==LBRACE||LA22_5==27) ) {
                                alt22=1;
                            }
                            else if ( (LA22_5==CONST||LA22_5==IDENTIFIER||LA22_5==29||LA22_5==31) ) {
                                alt22=2;
                            }
                            else {
                                if (backtracking>0) {failed=true; return retval;}
                                NoViableAltException nvae =
                                    new NoViableAltException("140:2: ( IDENTIFIER | IDENTIFIER '(' IDENTIFIER ')' )", 22, 5, input);

                                throw nvae;
                            }
                        }
                        else if ( ((LA22_4>=TYPEDEF && LA22_4<=29)||(LA22_4>=31 && LA22_4<=35)) ) {
                            alt22=1;
                        }
                        else {
                            if (backtracking>0) {failed=true; return retval;}
                            NoViableAltException nvae =
                                new NoViableAltException("140:2: ( IDENTIFIER | IDENTIFIER '(' IDENTIFIER ')' )", 22, 4, input);

                            throw nvae;
                        }
                    }
                    else if ( ((LA22_2>=TYPEDEF && LA22_2<=QUOTE)||(LA22_2>=LBRACE && LA22_2<=35)) ) {
                        alt22=1;
                    }
                    else {
                        if (backtracking>0) {failed=true; return retval;}
                        NoViableAltException nvae =
                            new NoViableAltException("140:2: ( IDENTIFIER | IDENTIFIER '(' IDENTIFIER ')' )", 22, 2, input);

                        throw nvae;
                    }
                }
                else if ( (LA22_1==CONST||LA22_1==IDENTIFIER||LA22_1==31) ) {
                    alt22=1;
                }
                else {
                    if (backtracking>0) {failed=true; return retval;}
                    NoViableAltException nvae =
                        new NoViableAltException("140:2: ( IDENTIFIER | IDENTIFIER '(' IDENTIFIER ')' )", 22, 1, input);

                    throw nvae;
                }
            }
            else {
                if (backtracking>0) {failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("140:2: ( IDENTIFIER | IDENTIFIER '(' IDENTIFIER ')' )", 22, 0, input);

                throw nvae;
            }
            switch (alt22) {
                case 1 :
                    // /VMADL.j/src/de/sm/csimple/CSimple.g:140:3: IDENTIFIER
                    {
                    IDENTIFIER71=(Token)input.LT(1);
                    match(input,IDENTIFIER,FOLLOW_IDENTIFIER_in_typeRef587); if (failed) return retval;
                    if ( backtracking==0 ) {
                    IDENTIFIER71_tree = (Object)adaptor.create(IDENTIFIER71);
                    adaptor.addChild(root_0, IDENTIFIER71_tree);
                    }

                    }
                    break;
                case 2 :
                    // /VMADL.j/src/de/sm/csimple/CSimple.g:141:5: IDENTIFIER '(' IDENTIFIER ')'
                    {
                    IDENTIFIER72=(Token)input.LT(1);
                    match(input,IDENTIFIER,FOLLOW_IDENTIFIER_in_typeRef593); if (failed) return retval;
                    if ( backtracking==0 ) {
                    IDENTIFIER72_tree = (Object)adaptor.create(IDENTIFIER72);
                    adaptor.addChild(root_0, IDENTIFIER72_tree);
                    }
                    char_literal73=(Token)input.LT(1);
                    match(input,29,FOLLOW_29_in_typeRef595); if (failed) return retval;
                    if ( backtracking==0 ) {
                    char_literal73_tree = (Object)adaptor.create(char_literal73);
                    adaptor.addChild(root_0, char_literal73_tree);
                    }
                    IDENTIFIER74=(Token)input.LT(1);
                    match(input,IDENTIFIER,FOLLOW_IDENTIFIER_in_typeRef597); if (failed) return retval;
                    if ( backtracking==0 ) {
                    IDENTIFIER74_tree = (Object)adaptor.create(IDENTIFIER74);
                    adaptor.addChild(root_0, IDENTIFIER74_tree);
                    }
                    char_literal75=(Token)input.LT(1);
                    match(input,30,FOLLOW_30_in_typeRef599); if (failed) return retval;
                    if ( backtracking==0 ) {
                    char_literal75_tree = (Object)adaptor.create(char_literal75);
                    adaptor.addChild(root_0, char_literal75_tree);
                    }

                    }
                    break;

            }

            // /VMADL.j/src/de/sm/csimple/CSimple.g:142:4: ( '*' )*
            loop23:
            do {
                int alt23=2;
                int LA23_0 = input.LA(1);

                if ( (LA23_0==31) ) {
                    alt23=1;
                }


                switch (alt23) {
            	case 1 :
            	    // /VMADL.j/src/de/sm/csimple/CSimple.g:142:5: '*'
            	    {
            	    char_literal76=(Token)input.LT(1);
            	    match(input,31,FOLLOW_31_in_typeRef607); if (failed) return retval;
            	    if ( backtracking==0 ) {
            	    char_literal76_tree = (Object)adaptor.create(char_literal76);
            	    adaptor.addChild(root_0, char_literal76_tree);
            	    }

            	    }
            	    break;

            	default :
            	    break loop23;
                }
            } while (true);


            }

            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (Object)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end typeRef

    public static class hexValue_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start hexValue
    // /VMADL.j/src/de/sm/csimple/CSimple.g:145:0: hexValue : HEXPREFIX ( DIGIT | 'a' .. 'f' | 'A' .. 'F' )+ ;
    public final hexValue_return hexValue() throws RecognitionException {
        hexValue_return retval = new hexValue_return();
        retval.start = input.LT(1);

        Object root_0 = null;

        Token HEXPREFIX77=null;
        Token set78=null;

        Object HEXPREFIX77_tree=null;
        Object set78_tree=null;

        try {
            // /VMADL.j/src/de/sm/csimple/CSimple.g:145:9: ( HEXPREFIX ( DIGIT | 'a' .. 'f' | 'A' .. 'F' )+ )
            // /VMADL.j/src/de/sm/csimple/CSimple.g:146:2: HEXPREFIX ( DIGIT | 'a' .. 'f' | 'A' .. 'F' )+
            {
            root_0 = (Object)adaptor.nil();

            HEXPREFIX77=(Token)input.LT(1);
            match(input,HEXPREFIX,FOLLOW_HEXPREFIX_in_hexValue618); if (failed) return retval;
            if ( backtracking==0 ) {
            HEXPREFIX77_tree = (Object)adaptor.create(HEXPREFIX77);
            adaptor.addChild(root_0, HEXPREFIX77_tree);
            }
            // /VMADL.j/src/de/sm/csimple/CSimple.g:146:12: ( DIGIT | 'a' .. 'f' | 'A' .. 'F' )+
            int cnt24=0;
            loop24:
            do {
                int alt24=2;
                int LA24_0 = input.LA(1);

                if ( (LA24_0==DIGIT) ) {
                    alt24=1;
                }


                switch (alt24) {
            	case 1 :
            	    // /VMADL.j/src/de/sm/csimple/CSimple.g:
            	    {
            	    set78=(Token)input.LT(1);
            	    if ( input.LA(1)==DIGIT ) {
            	        input.consume();
            	        if ( backtracking==0 ) adaptor.addChild(root_0, adaptor.create(set78));
            	        errorRecovery=false;failed=false;
            	    }
            	    else {
            	        if (backtracking>0) {failed=true; return retval;}
            	        MismatchedSetException mse =
            	            new MismatchedSetException(null,input);
            	        recoverFromMismatchedSet(input,mse,FOLLOW_set_in_hexValue620);    throw mse;
            	    }


            	    }
            	    break;

            	default :
            	    if ( cnt24 >= 1 ) break loop24;
            	    if (backtracking>0) {failed=true; return retval;}
                        EarlyExitException eee =
                            new EarlyExitException(24, input);
                        throw eee;
                }
                cnt24++;
            } while (true);


            }

            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (Object)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end hexValue

    // $ANTLR start synpred41
    public final void synpred41_fragment() throws RecognitionException {   
        // /VMADL.j/src/de/sm/csimple/CSimple.g:132:14: (~ ( LBRACE | RBRACE ) )
        // /VMADL.j/src/de/sm/csimple/CSimple.g:132:14: ~ ( LBRACE | RBRACE )
        {
        if ( (input.LA(1)>=TYPEDEF && input.LA(1)<=IDENTIFIER)||(input.LA(1)>=DIGIT && input.LA(1)<=35) ) {
            input.consume();
            errorRecovery=false;failed=false;
        }
        else {
            if (backtracking>0) {failed=true; return ;}
            MismatchedSetException mse =
                new MismatchedSetException(null,input);
            recoverFromMismatchedSet(input,mse,FOLLOW_set_in_synpred41548);    throw mse;
        }


        }
    }
    // $ANTLR end synpred41

    public final boolean synpred41() {
        backtracking++;
        int start = input.mark();
        try {
            synpred41_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !failed;
        input.rewind(start);
        backtracking--;
        failed=false;
        return success;
    }


    protected DFA1 dfa1 = new DFA1(this);
    protected DFA2 dfa2 = new DFA2(this);
    protected DFA10 dfa10 = new DFA10(this);
    static final String DFA1_eotS =
        "\26\uffff";
    static final String DFA1_eofS =
        "\1\1\25\uffff";
    static final String DFA1_minS =
        "\1\4\3\uffff\1\11\1\7\1\uffff\1\16\2\uffff\1\7\1\16\1\11\1\30\1"+
        "\uffff\1\11\1\36\1\uffff\1\16\1\11\1\36\1\11";
    static final String DFA1_maxS =
        "\1\34\3\uffff\1\37\1\16\1\uffff\1\16\2\uffff\2\16\2\37\1\uffff\1"+
        "\37\1\36\1\uffff\1\16\1\37\1\36\1\37";
    static final String DFA1_acceptS =
        "\1\uffff\1\10\1\1\1\2\2\uffff\1\3\1\uffff\1\4\1\6\4\uffff\1\7\2"+
        "\uffff\1\5\4\uffff";
    static final String DFA1_specialS =
        "\26\uffff}>";
    static final String[] DFA1_transitionS = {
            "\1\2\1\3\1\12\1\6\1\5\1\7\2\uffff\1\11\1\uffff\1\4\15\uffff"+
            "\1\10",
            "",
            "",
            "",
            "\1\6\4\uffff\1\15\16\uffff\1\13\1\uffff\1\14",
            "\1\6\1\uffff\1\7\3\uffff\1\16\1\17",
            "",
            "\1\17",
            "",
            "",
            "\1\6\1\uffff\1\7\4\uffff\1\17",
            "\1\20",
            "\1\6\4\uffff\1\15\20\uffff\1\14",
            "\1\21\1\uffff\2\21\1\uffff\1\6\1\uffff\1\6",
            "",
            "\1\6\4\uffff\1\15\16\uffff\1\22\1\uffff\1\14",
            "\1\23",
            "",
            "\1\24",
            "\1\6\4\uffff\1\15\1\3\17\uffff\1\14",
            "\1\25",
            "\1\6\4\uffff\1\15\20\uffff\1\14"
    };

    static final short[] DFA1_eot = DFA.unpackEncodedString(DFA1_eotS);
    static final short[] DFA1_eof = DFA.unpackEncodedString(DFA1_eofS);
    static final char[] DFA1_min = DFA.unpackEncodedStringToUnsignedChars(DFA1_minS);
    static final char[] DFA1_max = DFA.unpackEncodedStringToUnsignedChars(DFA1_maxS);
    static final short[] DFA1_accept = DFA.unpackEncodedString(DFA1_acceptS);
    static final short[] DFA1_special = DFA.unpackEncodedString(DFA1_specialS);
    static final short[][] DFA1_transition;

    static {
        int numStates = DFA1_transitionS.length;
        DFA1_transition = new short[numStates][];
        for (int i=0; i<numStates; i++) {
            DFA1_transition[i] = DFA.unpackEncodedString(DFA1_transitionS[i]);
        }
    }

    class DFA1 extends DFA {

        public DFA1(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 1;
            this.eot = DFA1_eot;
            this.eof = DFA1_eof;
            this.min = DFA1_min;
            this.max = DFA1_max;
            this.accept = DFA1_accept;
            this.special = DFA1_special;
            this.transition = DFA1_transition;
        }
        public String getDescription() {
            return "()* loopback of 75:2: ( typedefinition | struct | function | preprocessor | variable | NEWLINE | externDef )*";
        }
    }
    static final String DFA2_eotS =
        "\24\uffff";
    static final String DFA2_eofS =
        "\24\uffff";
    static final String DFA2_minS =
        "\1\4\3\uffff\1\11\1\7\1\uffff\1\16\2\uffff\1\16\1\11\1\30\1\11\1"+
        "\36\1\uffff\1\16\1\11\1\36\1\11";
    static final String DFA2_maxS =
        "\1\34\3\uffff\1\37\1\16\1\uffff\1\16\2\uffff\1\16\3\37\1\36\1\uffff"+
        "\1\16\1\37\1\36\1\37";
    static final String DFA2_acceptS =
        "\1\uffff\1\7\1\1\1\2\2\uffff\1\3\1\uffff\1\4\1\6\5\uffff\1\5\4\uffff";
    static final String DFA2_specialS =
        "\24\uffff}>";
    static final String[] DFA2_transitionS = {
            "\1\2\1\3\1\5\1\6\1\5\1\7\2\uffff\1\11\1\uffff\1\4\1\uffff\1"+
            "\1\13\uffff\1\10",
            "",
            "",
            "",
            "\1\6\4\uffff\1\14\16\uffff\1\12\1\uffff\1\13",
            "\1\6\1\uffff\1\7\4\uffff\1\15",
            "",
            "\1\15",
            "",
            "",
            "\1\16",
            "\1\6\4\uffff\1\14\20\uffff\1\13",
            "\1\17\1\uffff\2\17\1\uffff\1\6\1\uffff\1\6",
            "\1\6\4\uffff\1\14\16\uffff\1\20\1\uffff\1\13",
            "\1\21",
            "",
            "\1\22",
            "\1\6\4\uffff\1\14\1\3\17\uffff\1\13",
            "\1\23",
            "\1\6\4\uffff\1\14\20\uffff\1\13"
    };

    static final short[] DFA2_eot = DFA.unpackEncodedString(DFA2_eotS);
    static final short[] DFA2_eof = DFA.unpackEncodedString(DFA2_eofS);
    static final char[] DFA2_min = DFA.unpackEncodedStringToUnsignedChars(DFA2_minS);
    static final char[] DFA2_max = DFA.unpackEncodedStringToUnsignedChars(DFA2_maxS);
    static final short[] DFA2_accept = DFA.unpackEncodedString(DFA2_acceptS);
    static final short[] DFA2_special = DFA.unpackEncodedString(DFA2_specialS);
    static final short[][] DFA2_transition;

    static {
        int numStates = DFA2_transitionS.length;
        DFA2_transition = new short[numStates][];
        for (int i=0; i<numStates; i++) {
            DFA2_transition[i] = DFA.unpackEncodedString(DFA2_transitionS[i]);
        }
    }

    class DFA2 extends DFA {

        public DFA2(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 2;
            this.eot = DFA2_eot;
            this.eof = DFA2_eof;
            this.min = DFA2_min;
            this.max = DFA2_max;
            this.accept = DFA2_accept;
            this.special = DFA2_special;
            this.transition = DFA2_transition;
        }
        public String getDescription() {
            return "()* loopback of 82:3: ( typedefinition | struct | function | preprocessor | variable | NEWLINE )*";
        }
    }
    static final String DFA10_eotS =
        "\4\uffff";
    static final String DFA10_eofS =
        "\4\uffff";
    static final String DFA10_minS =
        "\2\4\2\uffff";
    static final String DFA10_maxS =
        "\2\43\2\uffff";
    static final String DFA10_acceptS =
        "\2\uffff\1\2\1\1";
    static final String DFA10_specialS =
        "\4\uffff}>";
    static final String[] DFA10_transitionS = {
            "\10\1\1\2\5\1\1\3\21\1",
            "\10\1\1\2\5\1\1\3\21\1",
            "",
            ""
    };

    static final short[] DFA10_eot = DFA.unpackEncodedString(DFA10_eotS);
    static final short[] DFA10_eof = DFA.unpackEncodedString(DFA10_eofS);
    static final char[] DFA10_min = DFA.unpackEncodedStringToUnsignedChars(DFA10_minS);
    static final char[] DFA10_max = DFA.unpackEncodedStringToUnsignedChars(DFA10_maxS);
    static final short[] DFA10_accept = DFA.unpackEncodedString(DFA10_acceptS);
    static final short[] DFA10_special = DFA.unpackEncodedString(DFA10_specialS);
    static final short[][] DFA10_transition;

    static {
        int numStates = DFA10_transitionS.length;
        DFA10_transition = new short[numStates][];
        for (int i=0; i<numStates; i++) {
            DFA10_transition[i] = DFA.unpackEncodedString(DFA10_transitionS[i]);
        }
    }

    class DFA10 extends DFA {

        public DFA10(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 10;
            this.eot = DFA10_eot;
            this.eof = DFA10_eof;
            this.min = DFA10_min;
            this.max = DFA10_max;
            this.accept = DFA10_accept;
            this.special = DFA10_special;
            this.transition = DFA10_transition;
        }
        public String getDescription() {
            return "()* loopback of 101:3: ( (~ ( PPCONTINUE | NEWLINE ) )* PPCONTINUE )*";
        }
    }
 

    public static final BitSet FOLLOW_typedefinition_in_definitions178 = new BitSet(new long[]{0x00000000100053F0L});
    public static final BitSet FOLLOW_struct_in_definitions182 = new BitSet(new long[]{0x00000000100053F0L});
    public static final BitSet FOLLOW_function_in_definitions186 = new BitSet(new long[]{0x00000000100053F0L});
    public static final BitSet FOLLOW_preprocessor_in_definitions190 = new BitSet(new long[]{0x00000000100053F0L});
    public static final BitSet FOLLOW_variable_in_definitions194 = new BitSet(new long[]{0x00000000100053F0L});
    public static final BitSet FOLLOW_NEWLINE_in_definitions198 = new BitSet(new long[]{0x00000000100053F0L});
    public static final BitSet FOLLOW_externDef_in_definitions202 = new BitSet(new long[]{0x00000000100053F0L});
    public static final BitSet FOLLOW_EOF_in_definitions208 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_EXTERN_in_externDef218 = new BitSet(new long[]{0x0000000000002000L});
    public static final BitSet FOLLOW_QUOTE_in_externDef220 = new BitSet(new long[]{0x0000000000004000L});
    public static final BitSet FOLLOW_IDENTIFIER_in_externDef222 = new BitSet(new long[]{0x0000000000002000L});
    public static final BitSet FOLLOW_QUOTE_in_externDef224 = new BitSet(new long[]{0x0000000000008000L});
    public static final BitSet FOLLOW_LBRACE_in_externDef229 = new BitSet(new long[]{0x00000000100153F0L});
    public static final BitSet FOLLOW_typedefinition_in_externDef234 = new BitSet(new long[]{0x00000000100153F0L});
    public static final BitSet FOLLOW_struct_in_externDef238 = new BitSet(new long[]{0x00000000100153F0L});
    public static final BitSet FOLLOW_function_in_externDef242 = new BitSet(new long[]{0x00000000100153F0L});
    public static final BitSet FOLLOW_preprocessor_in_externDef246 = new BitSet(new long[]{0x00000000100153F0L});
    public static final BitSet FOLLOW_variable_in_externDef250 = new BitSet(new long[]{0x00000000100153F0L});
    public static final BitSet FOLLOW_NEWLINE_in_externDef254 = new BitSet(new long[]{0x00000000100153F0L});
    public static final BitSet FOLLOW_RBRACE_in_externDef261 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_IDENTIFIER_in_literalValue270 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_DIGIT_in_literalValue274 = new BitSet(new long[]{0x0000000000020002L});
    public static final BitSet FOLLOW_hexValue_in_literalValue279 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_content_in_literalValue283 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_set_in_variable292 = new BitSet(new long[]{0x0000000000004200L});
    public static final BitSet FOLLOW_typeRef_in_variable302 = new BitSet(new long[]{0x0000000000004000L});
    public static final BitSet FOLLOW_IDENTIFIER_in_variable307 = new BitSet(new long[]{0x000000000D000000L});
    public static final BitSet FOLLOW_24_in_variable312 = new BitSet(new long[]{0x000000000202C800L});
    public static final BitSet FOLLOW_literalValue_in_variable315 = new BitSet(new long[]{0x0000000002000000L});
    public static final BitSet FOLLOW_25_in_variable319 = new BitSet(new long[]{0x000000000C000000L});
    public static final BitSet FOLLOW_26_in_variable326 = new BitSet(new long[]{0x000000000002C800L});
    public static final BitSet FOLLOW_literalValue_in_variable328 = new BitSet(new long[]{0x0000000008000000L});
    public static final BitSet FOLLOW_27_in_variable334 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_28_in_preprocessor345 = new BitSet(new long[]{0x0000000FFFFFFFF0L});
    public static final BitSet FOLLOW_set_in_preprocessor351 = new BitSet(new long[]{0x0000000FFFFFEFF0L});
    public static final BitSet FOLLOW_PPCONTINUE_in_preprocessor364 = new BitSet(new long[]{0x0000000FFFFFFFF0L});
    public static final BitSet FOLLOW_set_in_preprocessor371 = new BitSet(new long[]{0x0000000FFFFBFFF0L});
    public static final BitSet FOLLOW_NEWLINE_in_preprocessor389 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_TYPEDEF_in_typedefinition400 = new BitSet(new long[]{0x0000000FFFFFFFF0L});
    public static final BitSet FOLLOW_def_in_typedefinition402 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_STRUCT_in_struct411 = new BitSet(new long[]{0x0000000FFFFFFFF0L});
    public static final BitSet FOLLOW_def_in_struct413 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_IDENTIFIER_in_struct419 = new BitSet(new long[]{0x0000000020000000L});
    public static final BitSet FOLLOW_29_in_struct421 = new BitSet(new long[]{0x0000000000004000L});
    public static final BitSet FOLLOW_IDENTIFIER_in_struct423 = new BitSet(new long[]{0x0000000040000000L});
    public static final BitSet FOLLOW_30_in_struct425 = new BitSet(new long[]{0x0000000000008000L});
    public static final BitSet FOLLOW_content_in_struct427 = new BitSet(new long[]{0x0000000008000000L});
    public static final BitSet FOLLOW_27_in_struct429 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_content_in_def441 = new BitSet(new long[]{0x0000000FFFFFFFF0L});
    public static final BitSet FOLLOW_set_in_def445 = new BitSet(new long[]{0x0000000FFFFFFFF0L});
    public static final BitSet FOLLOW_27_in_def457 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_set_in_function466 = new BitSet(new long[]{0x0000000000004280L});
    public static final BitSet FOLLOW_INLINE_in_function476 = new BitSet(new long[]{0x0000000000004200L});
    public static final BitSet FOLLOW_typeRef_in_function483 = new BitSet(new long[]{0x0000000000004200L});
    public static final BitSet FOLLOW_typeRef_in_function487 = new BitSet(new long[]{0x0000000020000000L});
    public static final BitSet FOLLOW_29_in_function489 = new BitSet(new long[]{0x0000000FFFFFFFF0L});
    public static final BitSet FOLLOW_set_in_function491 = new BitSet(new long[]{0x0000000FFFFFFFF0L});
    public static final BitSet FOLLOW_30_in_function497 = new BitSet(new long[]{0x0000000008008400L});
    public static final BitSet FOLLOW_content_in_function501 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ATTR_in_function509 = new BitSet(new long[]{0x0000000020000000L});
    public static final BitSet FOLLOW_29_in_function511 = new BitSet(new long[]{0x0000000020000000L});
    public static final BitSet FOLLOW_29_in_function513 = new BitSet(new long[]{0x0000000000004000L});
    public static final BitSet FOLLOW_IDENTIFIER_in_function515 = new BitSet(new long[]{0x0000000040000000L});
    public static final BitSet FOLLOW_30_in_function517 = new BitSet(new long[]{0x0000000040000000L});
    public static final BitSet FOLLOW_30_in_function519 = new BitSet(new long[]{0x0000000008000000L});
    public static final BitSet FOLLOW_27_in_function527 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_content_in_contentcontent543 = new BitSet(new long[]{0x0000000FFFFEFFF2L});
    public static final BitSet FOLLOW_set_in_contentcontent548 = new BitSet(new long[]{0x0000000FFFFEFFF2L});
    public static final BitSet FOLLOW_LBRACE_in_content569 = new BitSet(new long[]{0x0000000FFFFFFFF0L});
    public static final BitSet FOLLOW_contentcontent_in_content571 = new BitSet(new long[]{0x0000000000010000L});
    public static final BitSet FOLLOW_RBRACE_in_content573 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_CONST_in_typeRef582 = new BitSet(new long[]{0x0000000000004000L});
    public static final BitSet FOLLOW_IDENTIFIER_in_typeRef587 = new BitSet(new long[]{0x0000000080000002L});
    public static final BitSet FOLLOW_IDENTIFIER_in_typeRef593 = new BitSet(new long[]{0x0000000020000000L});
    public static final BitSet FOLLOW_29_in_typeRef595 = new BitSet(new long[]{0x0000000000004000L});
    public static final BitSet FOLLOW_IDENTIFIER_in_typeRef597 = new BitSet(new long[]{0x0000000040000000L});
    public static final BitSet FOLLOW_30_in_typeRef599 = new BitSet(new long[]{0x0000000080000002L});
    public static final BitSet FOLLOW_31_in_typeRef607 = new BitSet(new long[]{0x0000000080000002L});
    public static final BitSet FOLLOW_HEXPREFIX_in_hexValue618 = new BitSet(new long[]{0x0000000000020000L});
    public static final BitSet FOLLOW_set_in_hexValue620 = new BitSet(new long[]{0x0000000000020002L});
    public static final BitSet FOLLOW_set_in_synpred41548 = new BitSet(new long[]{0x0000000000000002L});

}