// $ANTLR 3.0.1 /VMADL.j/src/de/sm/odl/Odl.g 2008-06-17 17:30:13

  package de.sm.odl;
  import de.sm.odl.elements.*;
  import de.sm.vmadl.elements.ServiceModule;


import org.antlr.runtime.*;
import java.util.Stack;
import java.util.List;
import java.util.ArrayList;


import org.antlr.runtime.tree.*;

public class OdlParser extends Parser {
    public static final String[] tokenNames = new String[] {
        "<invalid>", "<EOR>", "<DOWN>", "<UP>", "CLASS", "TRAIT", "REFINE", "BEFORE", "CONST", "RESTRICT", "ZERO_ARR", "NEWLINE", "IDENTIFIER", "LBRACE", "RBRACE", "COLON", "LPARENTHESIS", "RPARENTHESIS", "POSITION", "LETTER", "DIGIT", "WS", "COMMENT", "ML_COMMENT", "','", "'*'"
    };
    public static final int CLASS=4;
    public static final int RBRACE=14;
    public static final int TRAIT=5;
    public static final int LETTER=19;
    public static final int CONST=8;
    public static final int LBRACE=13;
    public static final int BEFORE=7;
    public static final int RPARENTHESIS=17;
    public static final int EOF=-1;
    public static final int ZERO_ARR=10;
    public static final int LPARENTHESIS=16;
    public static final int RESTRICT=9;
    public static final int POSITION=18;
    public static final int COLON=15;
    public static final int ML_COMMENT=23;
    public static final int WS=21;
    public static final int NEWLINE=11;
    public static final int IDENTIFIER=12;
    public static final int REFINE=6;
    public static final int DIGIT=20;
    public static final int COMMENT=22;

        public OdlParser(TokenStream input) {
            super(input);
        }
        
    protected TreeAdaptor adaptor = new CommonTreeAdaptor();

    public void setTreeAdaptor(TreeAdaptor adaptor) {
        this.adaptor = adaptor;
    }
    public TreeAdaptor getTreeAdaptor() {
        return adaptor;
    }

    public String[] getTokenNames() { return tokenNames; }
    public String getGrammarFileName() { return "/VMADL.j/src/de/sm/odl/Odl.g"; }


    	private TypeRegistry reg;
    	private ServiceModule module;


    public static class definitions_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start definitions
    // /VMADL.j/src/de/sm/odl/Odl.g:33:0: definitions[ TypeRegistry reg, ServiceModule module ] : ( classType | traitType | refineType | NEWLINE )* ;
    public final definitions_return definitions(TypeRegistry reg, ServiceModule module) throws RecognitionException {
        definitions_return retval = new definitions_return();
        retval.start = input.LT(1);

        Object root_0 = null;

        Token NEWLINE4=null;
        classType_return classType1 = null;

        traitType_return traitType2 = null;

        refineType_return refineType3 = null;


        Object NEWLINE4_tree=null;

        try {
            // /VMADL.j/src/de/sm/odl/Odl.g:33:55: ( ( classType | traitType | refineType | NEWLINE )* )
            // /VMADL.j/src/de/sm/odl/Odl.g:34:2: ( classType | traitType | refineType | NEWLINE )*
            {
            root_0 = (Object)adaptor.nil();

             this.reg		= reg;
            	  this.module = module; 
            	
            // /VMADL.j/src/de/sm/odl/Odl.g:37:2: ( classType | traitType | refineType | NEWLINE )*
            loop1:
            do {
                int alt1=5;
                switch ( input.LA(1) ) {
                case CLASS:
                    {
                    alt1=1;
                    }
                    break;
                case TRAIT:
                    {
                    alt1=2;
                    }
                    break;
                case REFINE:
                    {
                    alt1=3;
                    }
                    break;
                case NEWLINE:
                    {
                    alt1=4;
                    }
                    break;

                }

                switch (alt1) {
            	case 1 :
            	    // /VMADL.j/src/de/sm/odl/Odl.g:37:3: classType
            	    {
            	    pushFollow(FOLLOW_classType_in_definitions121);
            	    classType1=classType();
            	    _fsp--;

            	    adaptor.addChild(root_0, classType1.getTree());

            	    }
            	    break;
            	case 2 :
            	    // /VMADL.j/src/de/sm/odl/Odl.g:37:15: traitType
            	    {
            	    pushFollow(FOLLOW_traitType_in_definitions125);
            	    traitType2=traitType();
            	    _fsp--;

            	    adaptor.addChild(root_0, traitType2.getTree());

            	    }
            	    break;
            	case 3 :
            	    // /VMADL.j/src/de/sm/odl/Odl.g:37:27: refineType
            	    {
            	    pushFollow(FOLLOW_refineType_in_definitions129);
            	    refineType3=refineType();
            	    _fsp--;

            	    adaptor.addChild(root_0, refineType3.getTree());

            	    }
            	    break;
            	case 4 :
            	    // /VMADL.j/src/de/sm/odl/Odl.g:37:40: NEWLINE
            	    {
            	    NEWLINE4=(Token)input.LT(1);
            	    match(input,NEWLINE,FOLLOW_NEWLINE_in_definitions133); 
            	    NEWLINE4_tree = (Object)adaptor.create(NEWLINE4);
            	    adaptor.addChild(root_0, NEWLINE4_tree);


            	    }
            	    break;

            	default :
            	    break loop1;
                }
            } while (true);


            }

            retval.stop = input.LT(-1);

                retval.tree = (Object)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end definitions

    public static class classType_return extends ParserRuleReturnScope {
        public ClassType t;
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start classType
    // /VMADL.j/src/de/sm/odl/Odl.g:39:0: classType returns [ClassType t] : CLASS type[$t] ;
    public final classType_return classType() throws RecognitionException {
        classType_return retval = new classType_return();
        retval.start = input.LT(1);

        Object root_0 = null;

        Token CLASS5=null;
        type_return type6 = null;


        Object CLASS5_tree=null;

        try {
            // /VMADL.j/src/de/sm/odl/Odl.g:39:32: ( CLASS type[$t] )
            // /VMADL.j/src/de/sm/odl/Odl.g:40:2: CLASS type[$t]
            {
            root_0 = (Object)adaptor.nil();

            CLASS5=(Token)input.LT(1);
            match(input,CLASS,FOLLOW_CLASS_in_classType149); 
            CLASS5_tree = (Object)adaptor.create(CLASS5);
            adaptor.addChild(root_0, CLASS5_tree);

             retval.t = new ClassType(); 
            		retval.t.setModule(module);
            		module.types.add(retval.t); 
            	
            pushFollow(FOLLOW_type_in_classType157);
            type6=type(retval.t);
            _fsp--;

            adaptor.addChild(root_0, type6.getTree());

            }

            retval.stop = input.LT(-1);

                retval.tree = (Object)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end classType

    public static class traitType_return extends ParserRuleReturnScope {
        public TraitType t;
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start traitType
    // /VMADL.j/src/de/sm/odl/Odl.g:48:0: traitType returns [TraitType t] : TRAIT type[$t] ;
    public final traitType_return traitType() throws RecognitionException {
        traitType_return retval = new traitType_return();
        retval.start = input.LT(1);

        Object root_0 = null;

        Token TRAIT7=null;
        type_return type8 = null;


        Object TRAIT7_tree=null;

        try {
            // /VMADL.j/src/de/sm/odl/Odl.g:48:32: ( TRAIT type[$t] )
            // /VMADL.j/src/de/sm/odl/Odl.g:49:2: TRAIT type[$t]
            {
            root_0 = (Object)adaptor.nil();

            TRAIT7=(Token)input.LT(1);
            match(input,TRAIT,FOLLOW_TRAIT_in_traitType171); 
            TRAIT7_tree = (Object)adaptor.create(TRAIT7);
            adaptor.addChild(root_0, TRAIT7_tree);

             retval.t = new TraitType();
            	  retval.t.setModule(module);
            	  module.types.add(retval.t);
            	
            pushFollow(FOLLOW_type_in_traitType178);
            type8=type(retval.t);
            _fsp--;

            adaptor.addChild(root_0, type8.getTree());

            }

            retval.stop = input.LT(-1);

                retval.tree = (Object)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end traitType

    public static class refineType_return extends ParserRuleReturnScope {
        public Type t;
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start refineType
    // /VMADL.j/src/de/sm/odl/Odl.g:57:0: refineType returns [Type t] : REFINE IDENTIFIER LBRACE content[$t] RBRACE ;
    public final refineType_return refineType() throws RecognitionException {
        refineType_return retval = new refineType_return();
        retval.start = input.LT(1);

        Object root_0 = null;

        Token REFINE9=null;
        Token IDENTIFIER10=null;
        Token LBRACE11=null;
        Token RBRACE13=null;
        content_return content12 = null;


        Object REFINE9_tree=null;
        Object IDENTIFIER10_tree=null;
        Object LBRACE11_tree=null;
        Object RBRACE13_tree=null;

        try {
            // /VMADL.j/src/de/sm/odl/Odl.g:57:28: ( REFINE IDENTIFIER LBRACE content[$t] RBRACE )
            // /VMADL.j/src/de/sm/odl/Odl.g:58:2: REFINE IDENTIFIER LBRACE content[$t] RBRACE
            {
            root_0 = (Object)adaptor.nil();

            REFINE9=(Token)input.LT(1);
            match(input,REFINE,FOLLOW_REFINE_in_refineType192); 
            REFINE9_tree = (Object)adaptor.create(REFINE9);
            adaptor.addChild(root_0, REFINE9_tree);

            IDENTIFIER10=(Token)input.LT(1);
            match(input,IDENTIFIER,FOLLOW_IDENTIFIER_in_refineType194); 
            IDENTIFIER10_tree = (Object)adaptor.create(IDENTIFIER10);
            adaptor.addChild(root_0, IDENTIFIER10_tree);

             retval.t = reg.get(IDENTIFIER10.getText()); 
            LBRACE11=(Token)input.LT(1);
            match(input,LBRACE,FOLLOW_LBRACE_in_refineType199); 
            LBRACE11_tree = (Object)adaptor.create(LBRACE11);
            adaptor.addChild(root_0, LBRACE11_tree);

            pushFollow(FOLLOW_content_in_refineType201);
            content12=content(retval.t);
            _fsp--;

            adaptor.addChild(root_0, content12.getTree());
            RBRACE13=(Token)input.LT(1);
            match(input,RBRACE,FOLLOW_RBRACE_in_refineType204); 
            RBRACE13_tree = (Object)adaptor.create(RBRACE13);
            adaptor.addChild(root_0, RBRACE13_tree);


            }

            retval.stop = input.LT(-1);

                retval.tree = (Object)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end refineType

    public static class type_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start type
    // /VMADL.j/src/de/sm/odl/Odl.g:62:0: type[ Type t ] : IDENTIFIER inheritance[$t] LBRACE content[$t] RBRACE ;
    public final type_return type(Type t) throws RecognitionException {
        type_return retval = new type_return();
        retval.start = input.LT(1);

        Object root_0 = null;

        Token IDENTIFIER14=null;
        Token LBRACE16=null;
        Token RBRACE18=null;
        inheritance_return inheritance15 = null;

        content_return content17 = null;


        Object IDENTIFIER14_tree=null;
        Object LBRACE16_tree=null;
        Object RBRACE18_tree=null;

        try {
            // /VMADL.j/src/de/sm/odl/Odl.g:62:16: ( IDENTIFIER inheritance[$t] LBRACE content[$t] RBRACE )
            // /VMADL.j/src/de/sm/odl/Odl.g:63:2: IDENTIFIER inheritance[$t] LBRACE content[$t] RBRACE
            {
            root_0 = (Object)adaptor.nil();

            IDENTIFIER14=(Token)input.LT(1);
            match(input,IDENTIFIER,FOLLOW_IDENTIFIER_in_type216); 
            IDENTIFIER14_tree = (Object)adaptor.create(IDENTIFIER14);
            adaptor.addChild(root_0, IDENTIFIER14_tree);

            t.setName(IDENTIFIER14.getText()); reg.register(t); 
            pushFollow(FOLLOW_inheritance_in_type221);
            inheritance15=inheritance(t);
            _fsp--;

            adaptor.addChild(root_0, inheritance15.getTree());
            LBRACE16=(Token)input.LT(1);
            match(input,LBRACE,FOLLOW_LBRACE_in_type226); 
            LBRACE16_tree = (Object)adaptor.create(LBRACE16);
            adaptor.addChild(root_0, LBRACE16_tree);

            pushFollow(FOLLOW_content_in_type228);
            content17=content(t);
            _fsp--;

            adaptor.addChild(root_0, content17.getTree());
            RBRACE18=(Token)input.LT(1);
            match(input,RBRACE,FOLLOW_RBRACE_in_type231); 
            RBRACE18_tree = (Object)adaptor.create(RBRACE18);
            adaptor.addChild(root_0, RBRACE18_tree);


            }

            retval.stop = input.LT(-1);

                retval.tree = (Object)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end type

    public static class inheritance_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start inheritance
    // /VMADL.j/src/de/sm/odl/Odl.g:68:0: inheritance[Type t] : ( COLON baseclass= IDENTIFIER ( ',' trait= IDENTIFIER )* )? ;
    public final inheritance_return inheritance(Type t) throws RecognitionException {
        inheritance_return retval = new inheritance_return();
        retval.start = input.LT(1);

        Object root_0 = null;

        Token baseclass=null;
        Token trait=null;
        Token COLON19=null;
        Token char_literal20=null;

        Object baseclass_tree=null;
        Object trait_tree=null;
        Object COLON19_tree=null;
        Object char_literal20_tree=null;

        try {
            // /VMADL.j/src/de/sm/odl/Odl.g:68:21: ( ( COLON baseclass= IDENTIFIER ( ',' trait= IDENTIFIER )* )? )
            // /VMADL.j/src/de/sm/odl/Odl.g:69:2: ( COLON baseclass= IDENTIFIER ( ',' trait= IDENTIFIER )* )?
            {
            root_0 = (Object)adaptor.nil();

            // /VMADL.j/src/de/sm/odl/Odl.g:69:2: ( COLON baseclass= IDENTIFIER ( ',' trait= IDENTIFIER )* )?
            int alt3=2;
            int LA3_0 = input.LA(1);

            if ( (LA3_0==COLON) ) {
                alt3=1;
            }
            switch (alt3) {
                case 1 :
                    // /VMADL.j/src/de/sm/odl/Odl.g:69:3: COLON baseclass= IDENTIFIER ( ',' trait= IDENTIFIER )*
                    {
                    COLON19=(Token)input.LT(1);
                    match(input,COLON,FOLLOW_COLON_in_inheritance244); 
                    COLON19_tree = (Object)adaptor.create(COLON19);
                    adaptor.addChild(root_0, COLON19_tree);

                    baseclass=(Token)input.LT(1);
                    match(input,IDENTIFIER,FOLLOW_IDENTIFIER_in_inheritance248); 
                    baseclass_tree = (Object)adaptor.create(baseclass);
                    adaptor.addChild(root_0, baseclass_tree);

                    t.setBaseclass(reg.get(baseclass.getText())); 
                    // /VMADL.j/src/de/sm/odl/Odl.g:70:3: ( ',' trait= IDENTIFIER )*
                    loop2:
                    do {
                        int alt2=2;
                        int LA2_0 = input.LA(1);

                        if ( (LA2_0==24) ) {
                            alt2=1;
                        }


                        switch (alt2) {
                    	case 1 :
                    	    // /VMADL.j/src/de/sm/odl/Odl.g:70:4: ',' trait= IDENTIFIER
                    	    {
                    	    char_literal20=(Token)input.LT(1);
                    	    match(input,24,FOLLOW_24_in_inheritance255); 
                    	    char_literal20_tree = (Object)adaptor.create(char_literal20);
                    	    adaptor.addChild(root_0, char_literal20_tree);

                    	    trait=(Token)input.LT(1);
                    	    match(input,IDENTIFIER,FOLLOW_IDENTIFIER_in_inheritance259); 
                    	    trait_tree = (Object)adaptor.create(trait);
                    	    adaptor.addChild(root_0, trait_tree);

                    	    t.addTrait((TraitType)reg.get(trait.getText()));

                    	    }
                    	    break;

                    	default :
                    	    break loop2;
                        }
                    } while (true);


                    }
                    break;

            }


            }

            retval.stop = input.LT(-1);

                retval.tree = (Object)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end inheritance

    public static class content_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start content
    // /VMADL.j/src/de/sm/odl/Odl.g:74:0: content[ Type t ] : ( NEWLINE | field[$t] | function[$t] )* ;
    public final content_return content(Type t) throws RecognitionException {
        content_return retval = new content_return();
        retval.start = input.LT(1);

        Object root_0 = null;

        Token NEWLINE21=null;
        field_return field22 = null;

        function_return function23 = null;


        Object NEWLINE21_tree=null;

        try {
            // /VMADL.j/src/de/sm/odl/Odl.g:74:19: ( ( NEWLINE | field[$t] | function[$t] )* )
            // /VMADL.j/src/de/sm/odl/Odl.g:75:3: ( NEWLINE | field[$t] | function[$t] )*
            {
            root_0 = (Object)adaptor.nil();

            // /VMADL.j/src/de/sm/odl/Odl.g:75:3: ( NEWLINE | field[$t] | function[$t] )*
            loop4:
            do {
                int alt4=4;
                alt4 = dfa4.predict(input);
                switch (alt4) {
            	case 1 :
            	    // /VMADL.j/src/de/sm/odl/Odl.g:75:4: NEWLINE
            	    {
            	    NEWLINE21=(Token)input.LT(1);
            	    match(input,NEWLINE,FOLLOW_NEWLINE_in_content282); 
            	    NEWLINE21_tree = (Object)adaptor.create(NEWLINE21);
            	    adaptor.addChild(root_0, NEWLINE21_tree);


            	    }
            	    break;
            	case 2 :
            	    // /VMADL.j/src/de/sm/odl/Odl.g:75:14: field[$t]
            	    {
            	    pushFollow(FOLLOW_field_in_content286);
            	    field22=field(t);
            	    _fsp--;

            	    adaptor.addChild(root_0, field22.getTree());

            	    }
            	    break;
            	case 3 :
            	    // /VMADL.j/src/de/sm/odl/Odl.g:75:26: function[$t]
            	    {
            	    pushFollow(FOLLOW_function_in_content291);
            	    function23=function(t);
            	    _fsp--;

            	    adaptor.addChild(root_0, function23.getTree());

            	    }
            	    break;

            	default :
            	    break loop4;
                }
            } while (true);


            }

            retval.stop = input.LT(-1);

                retval.tree = (Object)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end content

    public static class typeRef_return extends ParserRuleReturnScope {
        public TypeRef ref;
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start typeRef
    // /VMADL.j/src/de/sm/odl/Odl.g:78:0: typeRef returns [ TypeRef ref ] : ( CONST )? IDENTIFIER ( '*' )* ( RESTRICT )? ( CONST )? ;
    public final typeRef_return typeRef() throws RecognitionException {
        typeRef_return retval = new typeRef_return();
        retval.start = input.LT(1);

        Object root_0 = null;

        Token CONST24=null;
        Token IDENTIFIER25=null;
        Token char_literal26=null;
        Token RESTRICT27=null;
        Token CONST28=null;

        Object CONST24_tree=null;
        Object IDENTIFIER25_tree=null;
        Object char_literal26_tree=null;
        Object RESTRICT27_tree=null;
        Object CONST28_tree=null;

        try {
            // /VMADL.j/src/de/sm/odl/Odl.g:78:32: ( ( CONST )? IDENTIFIER ( '*' )* ( RESTRICT )? ( CONST )? )
            // /VMADL.j/src/de/sm/odl/Odl.g:79:2: ( CONST )? IDENTIFIER ( '*' )* ( RESTRICT )? ( CONST )?
            {
            root_0 = (Object)adaptor.nil();

             retval.ref = new TypeRef(); 
            // /VMADL.j/src/de/sm/odl/Odl.g:80:2: ( CONST )?
            int alt5=2;
            int LA5_0 = input.LA(1);

            if ( (LA5_0==CONST) ) {
                alt5=1;
            }
            switch (alt5) {
                case 1 :
                    // /VMADL.j/src/de/sm/odl/Odl.g:80:3: CONST
                    {
                    CONST24=(Token)input.LT(1);
                    match(input,CONST,FOLLOW_CONST_in_typeRef312); 
                    CONST24_tree = (Object)adaptor.create(CONST24);
                    adaptor.addChild(root_0, CONST24_tree);

                     retval.ref.constQ = true; 

                    }
                    break;

            }

            IDENTIFIER25=(Token)input.LT(1);
            match(input,IDENTIFIER,FOLLOW_IDENTIFIER_in_typeRef319); 
            IDENTIFIER25_tree = (Object)adaptor.create(IDENTIFIER25);
            adaptor.addChild(root_0, IDENTIFIER25_tree);

             retval.ref.name = IDENTIFIER25.getText(); 
            // /VMADL.j/src/de/sm/odl/Odl.g:82:2: ( '*' )*
            loop6:
            do {
                int alt6=2;
                int LA6_0 = input.LA(1);

                if ( (LA6_0==25) ) {
                    alt6=1;
                }


                switch (alt6) {
            	case 1 :
            	    // /VMADL.j/src/de/sm/odl/Odl.g:82:3: '*'
            	    {
            	    char_literal26=(Token)input.LT(1);
            	    match(input,25,FOLLOW_25_in_typeRef325); 
            	    char_literal26_tree = (Object)adaptor.create(char_literal26);
            	    adaptor.addChild(root_0, char_literal26_tree);

            	     retval.ref.incPtr(); 

            	    }
            	    break;

            	default :
            	    break loop6;
                }
            } while (true);

            // /VMADL.j/src/de/sm/odl/Odl.g:83:2: ( RESTRICT )?
            int alt7=2;
            int LA7_0 = input.LA(1);

            if ( (LA7_0==RESTRICT) ) {
                alt7=1;
            }
            switch (alt7) {
                case 1 :
                    // /VMADL.j/src/de/sm/odl/Odl.g:83:3: RESTRICT
                    {
                    RESTRICT27=(Token)input.LT(1);
                    match(input,RESTRICT,FOLLOW_RESTRICT_in_typeRef334); 
                    RESTRICT27_tree = (Object)adaptor.create(RESTRICT27);
                    adaptor.addChild(root_0, RESTRICT27_tree);

                     retval.ref.restrictQ = true; 

                    }
                    break;

            }

            // /VMADL.j/src/de/sm/odl/Odl.g:84:2: ( CONST )?
            int alt8=2;
            int LA8_0 = input.LA(1);

            if ( (LA8_0==CONST) ) {
                alt8=1;
            }
            switch (alt8) {
                case 1 :
                    // /VMADL.j/src/de/sm/odl/Odl.g:84:3: CONST
                    {
                    CONST28=(Token)input.LT(1);
                    match(input,CONST,FOLLOW_CONST_in_typeRef342); 
                    CONST28_tree = (Object)adaptor.create(CONST28);
                    adaptor.addChild(root_0, CONST28_tree);

                     retval.ref.constQ2 = true; 

                    }
                    break;

            }


            }

            retval.stop = input.LT(-1);

                retval.tree = (Object)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end typeRef

    public static class fieldname_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start fieldname
    // /VMADL.j/src/de/sm/odl/Odl.g:87:0: fieldname : IDENTIFIER ( ZERO_ARR )? ;
    public final fieldname_return fieldname() throws RecognitionException {
        fieldname_return retval = new fieldname_return();
        retval.start = input.LT(1);

        Object root_0 = null;

        Token IDENTIFIER29=null;
        Token ZERO_ARR30=null;

        Object IDENTIFIER29_tree=null;
        Object ZERO_ARR30_tree=null;

        try {
            // /VMADL.j/src/de/sm/odl/Odl.g:87:10: ( IDENTIFIER ( ZERO_ARR )? )
            // /VMADL.j/src/de/sm/odl/Odl.g:88:2: IDENTIFIER ( ZERO_ARR )?
            {
            root_0 = (Object)adaptor.nil();

            IDENTIFIER29=(Token)input.LT(1);
            match(input,IDENTIFIER,FOLLOW_IDENTIFIER_in_fieldname355); 
            IDENTIFIER29_tree = (Object)adaptor.create(IDENTIFIER29);
            adaptor.addChild(root_0, IDENTIFIER29_tree);

            // /VMADL.j/src/de/sm/odl/Odl.g:88:13: ( ZERO_ARR )?
            int alt9=2;
            int LA9_0 = input.LA(1);

            if ( (LA9_0==ZERO_ARR) ) {
                alt9=1;
            }
            switch (alt9) {
                case 1 :
                    // /VMADL.j/src/de/sm/odl/Odl.g:88:13: ZERO_ARR
                    {
                    ZERO_ARR30=(Token)input.LT(1);
                    match(input,ZERO_ARR,FOLLOW_ZERO_ARR_in_fieldname357); 
                    ZERO_ARR30_tree = (Object)adaptor.create(ZERO_ARR30);
                    adaptor.addChild(root_0, ZERO_ARR30_tree);


                    }
                    break;

            }


            }

            retval.stop = input.LT(-1);

                retval.tree = (Object)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end fieldname

    public static class field_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start field
    // /VMADL.j/src/de/sm/odl/Odl.g:90:0: field[ Type t ] : typeRef name= fieldname ( LBRACE BEFORE pos= fieldname RBRACE )? NEWLINE ;
    public final field_return field(Type t) throws RecognitionException {
        field_return retval = new field_return();
        retval.start = input.LT(1);

        Object root_0 = null;

        Token LBRACE32=null;
        Token BEFORE33=null;
        Token RBRACE34=null;
        Token NEWLINE35=null;
        fieldname_return name = null;

        fieldname_return pos = null;

        typeRef_return typeRef31 = null;


        Object LBRACE32_tree=null;
        Object BEFORE33_tree=null;
        Object RBRACE34_tree=null;
        Object NEWLINE35_tree=null;

        try {
            // /VMADL.j/src/de/sm/odl/Odl.g:90:17: ( typeRef name= fieldname ( LBRACE BEFORE pos= fieldname RBRACE )? NEWLINE )
            // /VMADL.j/src/de/sm/odl/Odl.g:91:2: typeRef name= fieldname ( LBRACE BEFORE pos= fieldname RBRACE )? NEWLINE
            {
            root_0 = (Object)adaptor.nil();

             Field f = new Field(); 
            pushFollow(FOLLOW_typeRef_in_field371);
            typeRef31=typeRef();
            _fsp--;

            adaptor.addChild(root_0, typeRef31.getTree());
             f.type = typeRef31.ref; 
            pushFollow(FOLLOW_fieldname_in_field384);
            name=fieldname();
            _fsp--;

            adaptor.addChild(root_0, name.getTree());
             f.name = input.toString(name.start,name.stop); 
            // /VMADL.j/src/de/sm/odl/Odl.g:94:2: ( LBRACE BEFORE pos= fieldname RBRACE )?
            int alt10=2;
            int LA10_0 = input.LA(1);

            if ( (LA10_0==LBRACE) ) {
                alt10=1;
            }
            switch (alt10) {
                case 1 :
                    // /VMADL.j/src/de/sm/odl/Odl.g:94:3: LBRACE BEFORE pos= fieldname RBRACE
                    {
                    LBRACE32=(Token)input.LT(1);
                    match(input,LBRACE,FOLLOW_LBRACE_in_field391); 
                    LBRACE32_tree = (Object)adaptor.create(LBRACE32);
                    adaptor.addChild(root_0, LBRACE32_tree);

                    BEFORE33=(Token)input.LT(1);
                    match(input,BEFORE,FOLLOW_BEFORE_in_field393); 
                    BEFORE33_tree = (Object)adaptor.create(BEFORE33);
                    adaptor.addChild(root_0, BEFORE33_tree);

                     f.positionPredicate = BEFORE33.getText(); 
                    pushFollow(FOLLOW_fieldname_in_field406);
                    pos=fieldname();
                    _fsp--;

                    adaptor.addChild(root_0, pos.getTree());
                     f.positionField = input.toString(pos.start,pos.stop); 
                    RBRACE34=(Token)input.LT(1);
                    match(input,RBRACE,FOLLOW_RBRACE_in_field411); 
                    RBRACE34_tree = (Object)adaptor.create(RBRACE34);
                    adaptor.addChild(root_0, RBRACE34_tree);


                    }
                    break;

            }

            NEWLINE35=(Token)input.LT(1);
            match(input,NEWLINE,FOLLOW_NEWLINE_in_field416); 
            NEWLINE35_tree = (Object)adaptor.create(NEWLINE35);
            adaptor.addChild(root_0, NEWLINE35_tree);

             t.addField(f); 

            }

            retval.stop = input.LT(-1);

                retval.tree = (Object)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end field

    public static class function_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start function
    // /VMADL.j/src/de/sm/odl/Odl.g:101:0: function[ Type t ] : returnType= typeRef name= IDENTIFIER LPARENTHESIS (paramType= typeRef (paramName= IDENTIFIER )? ( ',' moreParam= typeRef (moreName= IDENTIFIER )? )* )? RPARENTHESIS NEWLINE ;
    public final function_return function(Type t) throws RecognitionException {
        function_return retval = new function_return();
        retval.start = input.LT(1);

        Object root_0 = null;

        Token name=null;
        Token paramName=null;
        Token moreName=null;
        Token LPARENTHESIS36=null;
        Token char_literal37=null;
        Token RPARENTHESIS38=null;
        Token NEWLINE39=null;
        typeRef_return returnType = null;

        typeRef_return paramType = null;

        typeRef_return moreParam = null;


        Object name_tree=null;
        Object paramName_tree=null;
        Object moreName_tree=null;
        Object LPARENTHESIS36_tree=null;
        Object char_literal37_tree=null;
        Object RPARENTHESIS38_tree=null;
        Object NEWLINE39_tree=null;

        try {
            // /VMADL.j/src/de/sm/odl/Odl.g:101:20: (returnType= typeRef name= IDENTIFIER LPARENTHESIS (paramType= typeRef (paramName= IDENTIFIER )? ( ',' moreParam= typeRef (moreName= IDENTIFIER )? )* )? RPARENTHESIS NEWLINE )
            // /VMADL.j/src/de/sm/odl/Odl.g:102:2: returnType= typeRef name= IDENTIFIER LPARENTHESIS (paramType= typeRef (paramName= IDENTIFIER )? ( ',' moreParam= typeRef (moreName= IDENTIFIER )? )* )? RPARENTHESIS NEWLINE
            {
            root_0 = (Object)adaptor.nil();

            pushFollow(FOLLOW_typeRef_in_function432);
            returnType=typeRef();
            _fsp--;

            adaptor.addChild(root_0, returnType.getTree());
            name=(Token)input.LT(1);
            match(input,IDENTIFIER,FOLLOW_IDENTIFIER_in_function436); 
            name_tree = (Object)adaptor.create(name);
            adaptor.addChild(root_0, name_tree);

             Function f = new Function();
            		f.name = name.getText();
            		f.returnType = returnType.ref;
            		t.addFunction(f);
            	
            LPARENTHESIS36=(Token)input.LT(1);
            match(input,LPARENTHESIS,FOLLOW_LPARENTHESIS_in_function443); 
            LPARENTHESIS36_tree = (Object)adaptor.create(LPARENTHESIS36);
            adaptor.addChild(root_0, LPARENTHESIS36_tree);

            // /VMADL.j/src/de/sm/odl/Odl.g:109:3: (paramType= typeRef (paramName= IDENTIFIER )? ( ',' moreParam= typeRef (moreName= IDENTIFIER )? )* )?
            int alt14=2;
            int LA14_0 = input.LA(1);

            if ( (LA14_0==CONST||LA14_0==IDENTIFIER) ) {
                alt14=1;
            }
            switch (alt14) {
                case 1 :
                    // /VMADL.j/src/de/sm/odl/Odl.g:109:4: paramType= typeRef (paramName= IDENTIFIER )? ( ',' moreParam= typeRef (moreName= IDENTIFIER )? )*
                    {
                    pushFollow(FOLLOW_typeRef_in_function450);
                    paramType=typeRef();
                    _fsp--;

                    adaptor.addChild(root_0, paramType.getTree());
                    // /VMADL.j/src/de/sm/odl/Odl.g:109:31: (paramName= IDENTIFIER )?
                    int alt11=2;
                    int LA11_0 = input.LA(1);

                    if ( (LA11_0==IDENTIFIER) ) {
                        alt11=1;
                    }
                    switch (alt11) {
                        case 1 :
                            // /VMADL.j/src/de/sm/odl/Odl.g:109:31: paramName= IDENTIFIER
                            {
                            paramName=(Token)input.LT(1);
                            match(input,IDENTIFIER,FOLLOW_IDENTIFIER_in_function454); 
                            paramName_tree = (Object)adaptor.create(paramName);
                            adaptor.addChild(root_0, paramName_tree);


                            }
                            break;

                    }

                    f.addParam((paramName != null)?paramName.getText():null, paramType.ref);
                    // /VMADL.j/src/de/sm/odl/Odl.g:110:4: ( ',' moreParam= typeRef (moreName= IDENTIFIER )? )*
                    loop13:
                    do {
                        int alt13=2;
                        int LA13_0 = input.LA(1);

                        if ( (LA13_0==24) ) {
                            alt13=1;
                        }


                        switch (alt13) {
                    	case 1 :
                    	    // /VMADL.j/src/de/sm/odl/Odl.g:110:5: ',' moreParam= typeRef (moreName= IDENTIFIER )?
                    	    {
                    	    char_literal37=(Token)input.LT(1);
                    	    match(input,24,FOLLOW_24_in_function464); 
                    	    char_literal37_tree = (Object)adaptor.create(char_literal37);
                    	    adaptor.addChild(root_0, char_literal37_tree);

                    	    pushFollow(FOLLOW_typeRef_in_function468);
                    	    moreParam=typeRef();
                    	    _fsp--;

                    	    adaptor.addChild(root_0, moreParam.getTree());
                    	    // /VMADL.j/src/de/sm/odl/Odl.g:110:35: (moreName= IDENTIFIER )?
                    	    int alt12=2;
                    	    int LA12_0 = input.LA(1);

                    	    if ( (LA12_0==IDENTIFIER) ) {
                    	        alt12=1;
                    	    }
                    	    switch (alt12) {
                    	        case 1 :
                    	            // /VMADL.j/src/de/sm/odl/Odl.g:110:35: moreName= IDENTIFIER
                    	            {
                    	            moreName=(Token)input.LT(1);
                    	            match(input,IDENTIFIER,FOLLOW_IDENTIFIER_in_function472); 
                    	            moreName_tree = (Object)adaptor.create(moreName);
                    	            adaptor.addChild(root_0, moreName_tree);


                    	            }
                    	            break;

                    	    }

                    	    f.addParam((moreName != null)?moreName.getText():null, moreParam.ref);

                    	    }
                    	    break;

                    	default :
                    	    break loop13;
                        }
                    } while (true);


                    }
                    break;

            }

            RPARENTHESIS38=(Token)input.LT(1);
            match(input,RPARENTHESIS,FOLLOW_RPARENTHESIS_in_function490); 
            RPARENTHESIS38_tree = (Object)adaptor.create(RPARENTHESIS38);
            adaptor.addChild(root_0, RPARENTHESIS38_tree);

            NEWLINE39=(Token)input.LT(1);
            match(input,NEWLINE,FOLLOW_NEWLINE_in_function493); 
            NEWLINE39_tree = (Object)adaptor.create(NEWLINE39);
            adaptor.addChild(root_0, NEWLINE39_tree);


            }

            retval.stop = input.LT(-1);

                retval.tree = (Object)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end function


    protected DFA4 dfa4 = new DFA4(this);
    static final String DFA4_eotS =
        "\13\uffff";
    static final String DFA4_eofS =
        "\13\uffff";
    static final String DFA4_minS =
        "\1\10\2\uffff\1\14\3\10\1\14\1\12\2\uffff";
    static final String DFA4_maxS =
        "\1\16\2\uffff\1\14\2\31\2\14\1\20\2\uffff";
    static final String DFA4_acceptS =
        "\1\uffff\1\4\1\1\6\uffff\1\3\1\2";
    static final String DFA4_specialS =
        "\13\uffff}>";
    static final String[] DFA4_transitionS = {
            "\1\3\2\uffff\1\2\1\4\1\uffff\1\1",
            "",
            "",
            "\1\4",
            "\1\7\1\6\2\uffff\1\10\14\uffff\1\5",
            "\1\7\1\6\2\uffff\1\10\14\uffff\1\5",
            "\1\7\3\uffff\1\10",
            "\1\10",
            "\2\12\1\uffff\1\12\2\uffff\1\11",
            "",
            ""
    };

    static final short[] DFA4_eot = DFA.unpackEncodedString(DFA4_eotS);
    static final short[] DFA4_eof = DFA.unpackEncodedString(DFA4_eofS);
    static final char[] DFA4_min = DFA.unpackEncodedStringToUnsignedChars(DFA4_minS);
    static final char[] DFA4_max = DFA.unpackEncodedStringToUnsignedChars(DFA4_maxS);
    static final short[] DFA4_accept = DFA.unpackEncodedString(DFA4_acceptS);
    static final short[] DFA4_special = DFA.unpackEncodedString(DFA4_specialS);
    static final short[][] DFA4_transition;

    static {
        int numStates = DFA4_transitionS.length;
        DFA4_transition = new short[numStates][];
        for (int i=0; i<numStates; i++) {
            DFA4_transition[i] = DFA.unpackEncodedString(DFA4_transitionS[i]);
        }
    }

    class DFA4 extends DFA {

        public DFA4(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 4;
            this.eot = DFA4_eot;
            this.eof = DFA4_eof;
            this.min = DFA4_min;
            this.max = DFA4_max;
            this.accept = DFA4_accept;
            this.special = DFA4_special;
            this.transition = DFA4_transition;
        }
        public String getDescription() {
            return "()* loopback of 75:3: ( NEWLINE | field[$t] | function[$t] )*";
        }
    }
 

    public static final BitSet FOLLOW_classType_in_definitions121 = new BitSet(new long[]{0x0000000000000872L});
    public static final BitSet FOLLOW_traitType_in_definitions125 = new BitSet(new long[]{0x0000000000000872L});
    public static final BitSet FOLLOW_refineType_in_definitions129 = new BitSet(new long[]{0x0000000000000872L});
    public static final BitSet FOLLOW_NEWLINE_in_definitions133 = new BitSet(new long[]{0x0000000000000872L});
    public static final BitSet FOLLOW_CLASS_in_classType149 = new BitSet(new long[]{0x0000000000001000L});
    public static final BitSet FOLLOW_type_in_classType157 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_TRAIT_in_traitType171 = new BitSet(new long[]{0x0000000000001000L});
    public static final BitSet FOLLOW_type_in_traitType178 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_REFINE_in_refineType192 = new BitSet(new long[]{0x0000000000001000L});
    public static final BitSet FOLLOW_IDENTIFIER_in_refineType194 = new BitSet(new long[]{0x0000000000002000L});
    public static final BitSet FOLLOW_LBRACE_in_refineType199 = new BitSet(new long[]{0x0000000000005900L});
    public static final BitSet FOLLOW_content_in_refineType201 = new BitSet(new long[]{0x0000000000004000L});
    public static final BitSet FOLLOW_RBRACE_in_refineType204 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_IDENTIFIER_in_type216 = new BitSet(new long[]{0x000000000000A000L});
    public static final BitSet FOLLOW_inheritance_in_type221 = new BitSet(new long[]{0x0000000000002000L});
    public static final BitSet FOLLOW_LBRACE_in_type226 = new BitSet(new long[]{0x0000000000005900L});
    public static final BitSet FOLLOW_content_in_type228 = new BitSet(new long[]{0x0000000000004000L});
    public static final BitSet FOLLOW_RBRACE_in_type231 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_COLON_in_inheritance244 = new BitSet(new long[]{0x0000000000001000L});
    public static final BitSet FOLLOW_IDENTIFIER_in_inheritance248 = new BitSet(new long[]{0x0000000001000002L});
    public static final BitSet FOLLOW_24_in_inheritance255 = new BitSet(new long[]{0x0000000000001000L});
    public static final BitSet FOLLOW_IDENTIFIER_in_inheritance259 = new BitSet(new long[]{0x0000000001000002L});
    public static final BitSet FOLLOW_NEWLINE_in_content282 = new BitSet(new long[]{0x0000000000001902L});
    public static final BitSet FOLLOW_field_in_content286 = new BitSet(new long[]{0x0000000000001902L});
    public static final BitSet FOLLOW_function_in_content291 = new BitSet(new long[]{0x0000000000001902L});
    public static final BitSet FOLLOW_CONST_in_typeRef312 = new BitSet(new long[]{0x0000000000001000L});
    public static final BitSet FOLLOW_IDENTIFIER_in_typeRef319 = new BitSet(new long[]{0x0000000002000302L});
    public static final BitSet FOLLOW_25_in_typeRef325 = new BitSet(new long[]{0x0000000002000302L});
    public static final BitSet FOLLOW_RESTRICT_in_typeRef334 = new BitSet(new long[]{0x0000000000000102L});
    public static final BitSet FOLLOW_CONST_in_typeRef342 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_IDENTIFIER_in_fieldname355 = new BitSet(new long[]{0x0000000000000402L});
    public static final BitSet FOLLOW_ZERO_ARR_in_fieldname357 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_typeRef_in_field371 = new BitSet(new long[]{0x0000000000001000L});
    public static final BitSet FOLLOW_fieldname_in_field384 = new BitSet(new long[]{0x0000000000002800L});
    public static final BitSet FOLLOW_LBRACE_in_field391 = new BitSet(new long[]{0x0000000000000080L});
    public static final BitSet FOLLOW_BEFORE_in_field393 = new BitSet(new long[]{0x0000000000001000L});
    public static final BitSet FOLLOW_fieldname_in_field406 = new BitSet(new long[]{0x0000000000004000L});
    public static final BitSet FOLLOW_RBRACE_in_field411 = new BitSet(new long[]{0x0000000000000800L});
    public static final BitSet FOLLOW_NEWLINE_in_field416 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_typeRef_in_function432 = new BitSet(new long[]{0x0000000000001000L});
    public static final BitSet FOLLOW_IDENTIFIER_in_function436 = new BitSet(new long[]{0x0000000000010000L});
    public static final BitSet FOLLOW_LPARENTHESIS_in_function443 = new BitSet(new long[]{0x0000000000021100L});
    public static final BitSet FOLLOW_typeRef_in_function450 = new BitSet(new long[]{0x0000000001021000L});
    public static final BitSet FOLLOW_IDENTIFIER_in_function454 = new BitSet(new long[]{0x0000000001020000L});
    public static final BitSet FOLLOW_24_in_function464 = new BitSet(new long[]{0x0000000000001100L});
    public static final BitSet FOLLOW_typeRef_in_function468 = new BitSet(new long[]{0x0000000001021000L});
    public static final BitSet FOLLOW_IDENTIFIER_in_function472 = new BitSet(new long[]{0x0000000001020000L});
    public static final BitSet FOLLOW_RPARENTHESIS_in_function490 = new BitSet(new long[]{0x0000000000000800L});
    public static final BitSet FOLLOW_NEWLINE_in_function493 = new BitSet(new long[]{0x0000000000000002L});

}