package de.sm.odl.elements;

public class TypeRef {
	public String name;
	private int ptrCount = 0;
	public boolean restrictQ = false;
	public boolean constQ = false;
	public boolean constQ2 = false;
	
	public void incPtr() {
		ptrCount++;
	}
	
	public int getPtrCount() {
		return ptrCount;
	}
	
	public String getCompleteName() {
		String name = "";
		if (constQ) name += "const ";
		
		String ptr = "";
		for (int i = 0; i < ptrCount; i++) {
			ptr = ptr + "*";
		}
		name += this.name + ptr;
		

		if (restrictQ) name += " restrict";
		if (constQ2) name += " const";
		return name;
	}
}
