package de.sm.vmadl.elements;

import java.io.File;
import java.util.ArrayList;
import java.util.List;

public class ServiceModule extends ServiceInterface {

	public List<OptionalRelation> relations;
	
	public ServiceModule() {
		super();
		relations = new ArrayList<OptionalRelation>();
	}
	
	/**
	 * This field is used to remember whether the module was already initialized completely.
	 * Is false if this module has been created to satisfy a require statement.
	 */
	public boolean initialized = false;
	
	/**
	 * Name of the service.
	 */
	public String name;
	
	/**
	 * The file where this module has been defined in.
	 */
	public File file;
}
