#ifndef SCHEDULER_H
#define SCHEDULER_H

#include "vmobjects/VMObject.h"
#include "vmobjects/VMFrame.h"

//runs the passed thread
void  Scheduler_run_thread(pVMObject thread, pVMFrame frame);
//saves the thread frame to the threadlist
void  Scheduler_register_thread_frame(pVMObject arg);
//removes thread frame from the thread list
void  Scheduler_unregister_thread_frame(pVMObject thread);
//puts the entire VM to sleep for the passed period of time
void  Scheduler_sleep(long duration);

//run the scheduler thread - no primitive - called from interpreter
void  Scheduler_run_scheduler_thread();

#endif /*SCHEDULER_H*/
