#include "Interpreter_threaded.h"
#include "vm/Universe.h"

char* bytecodes_get_bytecode_name(bytecode_t bc) {
    if (universe_use_threaded_interpretation && bc >= Interpreter_threaded_first_super_bc())
        return (char*)"SUPER INSTRUCTION";
    else
        return (char*)bytecode_names[bc];
}

void bytecodes_get_bytecode_length(bytecode_t bc, bytecode_t* result) {

    if (universe_use_threaded_interpretation)
        *result = inst_handler_entries[bc].length;
    else
        *result = bytecode_lengths[bc];// Return the length of the given bytecode
}
