<?php

$minResults = array();

$d = dir(".");
while (false !== ($entry = $d->read())) {
   if (is_dir($entry)) continue;

   $file = file($entry);
   $name = explode('.', $entry);
   $runName = $name[0];

   foreach($file as $line) {
     $parts = split(', ', $line);
     if (count($parts) == 6 && $parts[0] != 'Benchmark Name') {
       if (isset($minResults[$runName][$parts[0]])) {
         $minResults[$runName][$parts[0]] = min($minResults[$runName][$parts[0]], $parts[1]);
       } else {
         $minResults[$runName][$parts[0]] = $parts[1];
       }
     }
   }
}
$d->close();

$first = true;
foreach ($minResults as $runName => $results) {
  ksort($results);
  if ($first) {
    echo 'Run Name,';
    foreach ($results as $bench => $value) {
      echo "$bench,";
    }
    echo "\n";
    $first = false;
  }

  echo "$runName";
  foreach ($results as $bench => $value) {
    echo ",$value";
  }
  echo "\n";
}

