#ifndef MUTEX_H_
#define MUTEX_H_

#include <module.VMObjects>

extern "C" {

//Locks the access to the encapsulated Mutex
void _Mutex_lock(pVMObject object, pVMFrame frame);
// Frees the mutex 
void _Mutex_unlock(pVMObject object, pVMFrame frame);
/* Returns true if the mutex is free, false otherwise
 * Enables nonblocking mutex checks
 */ 
void _Mutex_isLocked(pVMObject object, pVMFrame frame);

void Mutex_new(pVMObject object, pVMFrame frame);

}

#endif /*MUTEX_H_*/
