package de.sm.metrics;

import java.io.File;

public class ImplementationModule extends Module {
	private int linesOfCode = 0;
	private int linesOfCodeWithStatements = 0;
	private int typedefCount;
	private int variableCount;
	private int structCount;
	private int preprocessorCount;
	private int functionSigCount;
	private int functionCount;
	private int adviceCount;
	private int pointcutCount;
	private int typeCount;
	private int combineCount;
	private int declarationCount;
	
	public ImplementationModule(File file) {
		super(file);
	}
	
	public int getLinesOfCode() {
		return linesOfCode;
	}
	
	public void setLinesOfCode(int loc) {
		linesOfCode = loc;
	}
	
	public int getSubModuleCount() {
		return 0;
	}
	
	public int getLinesOfCodeWithStatements() {
		return linesOfCodeWithStatements;
	}
	
	public void setLinesOfCodeWithStatements(int loc) {	
		linesOfCodeWithStatements = loc;
	}
	
	public int getFunctionCount() {
		return functionCount;
	}

	public void setFunctionCount(int value) {
		functionCount = value;
	}
	
	public int getFunctionSigCount() {
		return functionSigCount;
	}

	public void setFunctionSigCount(int val) {
		functionSigCount = val;
	}

	public int getPreprocessorCount() {
		return preprocessorCount;
	}
	
	public void setPreprocessorCount(int val) {
		preprocessorCount = val;
	}
	
	public int getStructCount() {
		return structCount;
	}

	public void setStructCount(int val) {
		structCount = val;
	}

	public int getVariableCount() {
		return variableCount;
	}
	
	public void setVariableCount(int val) {
		variableCount = val;
	}

	public void setTypedefCount(int val) {
		typedefCount = val;
	}

	public int getTypedefCount() {
		return typedefCount;
	}

	public void setAdviceCount(int val) {
		adviceCount = val;
	}

	public int getAdviceCount() {
		return adviceCount;
	}

	public void setPointcutCount(int val) {
		pointcutCount = val;
	}
	
	public int getPointcutCount() {
		return pointcutCount;
	}

	public void setTypeCount(int val) {
		typeCount = val;
	}
	
	public int getTypeCount() {
		return typeCount;
	}

	public void setCombineCount(int val) {
		combineCount = val;
	}
	
	public int getCombineCount() {
		return combineCount;
	}

	public void setDeclarationCount(int val) {
		declarationCount = val;
	}
	
	public int getDeclarationCount() {
		return declarationCount;
	}
}
