/**
 * 
 */
package de.sm.vmadl;

import de.sm.vmadl.elements.ServiceModule;

/**
 * @author gron
 *
 */
public class CompilerException extends Exception {

	/**
	 * Generated id.
	 */
	private static final long serialVersionUID = -6344394500651625613L;
	
	private ServiceModule module;
	
	public CompilerException(String msg, ServiceModule module) {
		super(msg);
		this.module = module; 
	}
	
	public ServiceModule getModule() {
		return module;
	}
}
