// $ANTLR 3.0.1 Vmadl__.g 2008-05-27 18:36:48

  package de.sm.vmadl;


import org.antlr.runtime.*;
import java.util.Stack;
import java.util.List;
import java.util.ArrayList;

public class VmadlLexer extends Lexer {
    public static final int EXPOSE=7;
    public static final int RBRACE=16;
    public static final int LETTER=17;
    public static final int LBRACE=15;
    public static final int FOR=12;
    public static final int BOOT=11;
    public static final int Tokens=25;
    public static final int T24=24;
    public static final int EOF=-1;
    public static final int T23=23;
    public static final int REQUIRE=10;
    public static final int ADVICE=8;
    public static final int POINTCUT=9;
    public static final int ML_COMMENT=22;
    public static final int WS=20;
    public static final int NEWLINE=13;
    public static final int SERVICE=4;
    public static final int SPECIAL=19;
    public static final int SHUTDOWN=6;
    public static final int DIGIT=18;
    public static final int COMMENT=21;
    public static final int SERVICE_NAME=14;
    public static final int STARTUP=5;
    public VmadlLexer() {;} 
    public VmadlLexer(CharStream input) {
        super(input);
    }
    public String getGrammarFileName() { return "Vmadl__.g"; }

    // $ANTLR start SERVICE
    public final void mSERVICE() throws RecognitionException {
        try {
            int _type = SERVICE;
            // Vmadl__.g:10:9: ( 'service' )
            // Vmadl__.g:10:11: 'service'
            {
            match("service"); 


            }

            this.type = _type;
        }
        finally {
        }
    }
    // $ANTLR end SERVICE

    // $ANTLR start STARTUP
    public final void mSTARTUP() throws RecognitionException {
        try {
            int _type = STARTUP;
            // Vmadl__.g:11:9: ( 'startup' )
            // Vmadl__.g:11:11: 'startup'
            {
            match("startup"); 


            }

            this.type = _type;
        }
        finally {
        }
    }
    // $ANTLR end STARTUP

    // $ANTLR start SHUTDOWN
    public final void mSHUTDOWN() throws RecognitionException {
        try {
            int _type = SHUTDOWN;
            // Vmadl__.g:12:10: ( 'shutdown' )
            // Vmadl__.g:12:12: 'shutdown'
            {
            match("shutdown"); 


            }

            this.type = _type;
        }
        finally {
        }
    }
    // $ANTLR end SHUTDOWN

    // $ANTLR start EXPOSE
    public final void mEXPOSE() throws RecognitionException {
        try {
            int _type = EXPOSE;
            // Vmadl__.g:13:8: ( 'expose' )
            // Vmadl__.g:13:10: 'expose'
            {
            match("expose"); 


            }

            this.type = _type;
        }
        finally {
        }
    }
    // $ANTLR end EXPOSE

    // $ANTLR start ADVICE
    public final void mADVICE() throws RecognitionException {
        try {
            int _type = ADVICE;
            // Vmadl__.g:14:8: ( 'advice' )
            // Vmadl__.g:14:10: 'advice'
            {
            match("advice"); 


            }

            this.type = _type;
        }
        finally {
        }
    }
    // $ANTLR end ADVICE

    // $ANTLR start POINTCUT
    public final void mPOINTCUT() throws RecognitionException {
        try {
            int _type = POINTCUT;
            // Vmadl__.g:15:10: ( 'pointcut' )
            // Vmadl__.g:15:12: 'pointcut'
            {
            match("pointcut"); 


            }

            this.type = _type;
        }
        finally {
        }
    }
    // $ANTLR end POINTCUT

    // $ANTLR start REQUIRE
    public final void mREQUIRE() throws RecognitionException {
        try {
            int _type = REQUIRE;
            // Vmadl__.g:16:9: ( 'require' )
            // Vmadl__.g:16:11: 'require'
            {
            match("require"); 


            }

            this.type = _type;
        }
        finally {
        }
    }
    // $ANTLR end REQUIRE

    // $ANTLR start BOOT
    public final void mBOOT() throws RecognitionException {
        try {
            int _type = BOOT;
            // Vmadl__.g:17:6: ( 'boot' )
            // Vmadl__.g:17:8: 'boot'
            {
            match("boot"); 


            }

            this.type = _type;
        }
        finally {
        }
    }
    // $ANTLR end BOOT

    // $ANTLR start FOR
    public final void mFOR() throws RecognitionException {
        try {
            int _type = FOR;
            // Vmadl__.g:18:5: ( 'for' )
            // Vmadl__.g:18:7: 'for'
            {
            match("for"); 


            }

            this.type = _type;
        }
        finally {
        }
    }
    // $ANTLR end FOR

    // $ANTLR start T23
    public final void mT23() throws RecognitionException {
        try {
            int _type = T23;
            // Vmadl__.g:19:5: ( ';' )
            // Vmadl__.g:19:7: ';'
            {
            match(';'); 

            }

            this.type = _type;
        }
        finally {
        }
    }
    // $ANTLR end T23

    // $ANTLR start T24
    public final void mT24() throws RecognitionException {
        try {
            int _type = T24;
            // Vmadl__.g:20:5: ( '#' )
            // Vmadl__.g:20:7: '#'
            {
            match('#'); 

            }

            this.type = _type;
        }
        finally {
        }
    }
    // $ANTLR end T24

    // $ANTLR start SERVICE_NAME
    public final void mSERVICE_NAME() throws RecognitionException {
        try {
            int _type = SERVICE_NAME;
            // Vmadl__.g:154:14: ( LETTER ( DIGIT | LETTER | '-' | '_' )* )
            // Vmadl__.g:154:16: LETTER ( DIGIT | LETTER | '-' | '_' )*
            {
            mLETTER(); 
            // Vmadl__.g:154:23: ( DIGIT | LETTER | '-' | '_' )*
            loop1:
            do {
                int alt1=2;
                int LA1_0 = input.LA(1);

                if ( (LA1_0=='-'||(LA1_0>='0' && LA1_0<='9')||(LA1_0>='A' && LA1_0<='Z')||LA1_0=='_'||(LA1_0>='a' && LA1_0<='z')) ) {
                    alt1=1;
                }


                switch (alt1) {
            	case 1 :
            	    // Vmadl__.g:
            	    {
            	    if ( input.LA(1)=='-'||(input.LA(1)>='0' && input.LA(1)<='9')||(input.LA(1)>='A' && input.LA(1)<='Z')||input.LA(1)=='_'||(input.LA(1)>='a' && input.LA(1)<='z') ) {
            	        input.consume();

            	    }
            	    else {
            	        MismatchedSetException mse =
            	            new MismatchedSetException(null,input);
            	        recover(mse);    throw mse;
            	    }


            	    }
            	    break;

            	default :
            	    break loop1;
                }
            } while (true);


            }

            this.type = _type;
        }
        finally {
        }
    }
    // $ANTLR end SERVICE_NAME

    // $ANTLR start DIGIT
    public final void mDIGIT() throws RecognitionException {
        try {
            int _type = DIGIT;
            // Vmadl__.g:157:5: ( '0' .. '9' )
            // Vmadl__.g:157:10: '0' .. '9'
            {
            matchRange('0','9'); 

            }

            this.type = _type;
        }
        finally {
        }
    }
    // $ANTLR end DIGIT

    // $ANTLR start LETTER
    public final void mLETTER() throws RecognitionException {
        try {
            // Vmadl__.g:160:5: ( 'a' .. 'z' | 'A' .. 'Z' )
            // Vmadl__.g:
            {
            if ( (input.LA(1)>='A' && input.LA(1)<='Z')||(input.LA(1)>='a' && input.LA(1)<='z') ) {
                input.consume();

            }
            else {
                MismatchedSetException mse =
                    new MismatchedSetException(null,input);
                recover(mse);    throw mse;
            }


            }

        }
        finally {
        }
    }
    // $ANTLR end LETTER

    // $ANTLR start SPECIAL
    public final void mSPECIAL() throws RecognitionException {
        try {
            int _type = SPECIAL;
            // Vmadl__.g:164:9: ( '(' | ')' | ':' | '=' | '.' | '*' | '+' | '%' | '#' | '/' | '\\\\' | '_' | ';' | ',' | '|' | '&' | '-' | '\"' | '<' | '>' | '[' | ']' | '!' | '\\'' )
            // Vmadl__.g:
            {
            if ( (input.LA(1)>='!' && input.LA(1)<='#')||(input.LA(1)>='%' && input.LA(1)<='/')||(input.LA(1)>=':' && input.LA(1)<='>')||(input.LA(1)>='[' && input.LA(1)<=']')||input.LA(1)=='_'||input.LA(1)=='|' ) {
                input.consume();

            }
            else {
                MismatchedSetException mse =
                    new MismatchedSetException(null,input);
                recover(mse);    throw mse;
            }


            }

            this.type = _type;
        }
        finally {
        }
    }
    // $ANTLR end SPECIAL

    // $ANTLR start NEWLINE
    public final void mNEWLINE() throws RecognitionException {
        try {
            int _type = NEWLINE;
            // Vmadl__.g:168:3: ( ( '\\r' )? '\\n' )
            // Vmadl__.g:168:5: ( '\\r' )? '\\n'
            {
            // Vmadl__.g:168:5: ( '\\r' )?
            int alt2=2;
            int LA2_0 = input.LA(1);

            if ( (LA2_0=='\r') ) {
                alt2=1;
            }
            switch (alt2) {
                case 1 :
                    // Vmadl__.g:168:5: '\\r'
                    {
                    match('\r'); 

                    }
                    break;

            }

            match('\n'); 

            }

            this.type = _type;
        }
        finally {
        }
    }
    // $ANTLR end NEWLINE

    // $ANTLR start WS
    public final void mWS() throws RecognitionException {
        try {
            int _type = WS;
            // Vmadl__.g:173:3: ( ( ' ' | '\\t' )+ )
            // Vmadl__.g:173:5: ( ' ' | '\\t' )+
            {
            // Vmadl__.g:173:5: ( ' ' | '\\t' )+
            int cnt3=0;
            loop3:
            do {
                int alt3=2;
                int LA3_0 = input.LA(1);

                if ( (LA3_0=='\t'||LA3_0==' ') ) {
                    alt3=1;
                }


                switch (alt3) {
            	case 1 :
            	    // Vmadl__.g:
            	    {
            	    if ( input.LA(1)=='\t'||input.LA(1)==' ' ) {
            	        input.consume();

            	    }
            	    else {
            	        MismatchedSetException mse =
            	            new MismatchedSetException(null,input);
            	        recover(mse);    throw mse;
            	    }


            	    }
            	    break;

            	default :
            	    if ( cnt3 >= 1 ) break loop3;
                        EarlyExitException eee =
                            new EarlyExitException(3, input);
                        throw eee;
                }
                cnt3++;
            } while (true);

             channel=HIDDEN; 

            }

            this.type = _type;
        }
        finally {
        }
    }
    // $ANTLR end WS

    // $ANTLR start COMMENT
    public final void mCOMMENT() throws RecognitionException {
        try {
            int _type = COMMENT;
            // Vmadl__.g:178:3: ( '//' (~ ( '\\n' | '\\r' ) )* NEWLINE )
            // Vmadl__.g:178:5: '//' (~ ( '\\n' | '\\r' ) )* NEWLINE
            {
            match("//"); 

            // Vmadl__.g:178:10: (~ ( '\\n' | '\\r' ) )*
            loop4:
            do {
                int alt4=2;
                int LA4_0 = input.LA(1);

                if ( ((LA4_0>='\u0000' && LA4_0<='\t')||(LA4_0>='\u000B' && LA4_0<='\f')||(LA4_0>='\u000E' && LA4_0<='\uFFFE')) ) {
                    alt4=1;
                }


                switch (alt4) {
            	case 1 :
            	    // Vmadl__.g:178:11: ~ ( '\\n' | '\\r' )
            	    {
            	    if ( (input.LA(1)>='\u0000' && input.LA(1)<='\t')||(input.LA(1)>='\u000B' && input.LA(1)<='\f')||(input.LA(1)>='\u000E' && input.LA(1)<='\uFFFE') ) {
            	        input.consume();

            	    }
            	    else {
            	        MismatchedSetException mse =
            	            new MismatchedSetException(null,input);
            	        recover(mse);    throw mse;
            	    }


            	    }
            	    break;

            	default :
            	    break loop4;
                }
            } while (true);

            mNEWLINE(); 
             channel=HIDDEN; 

            }

            this.type = _type;
        }
        finally {
        }
    }
    // $ANTLR end COMMENT

    // $ANTLR start ML_COMMENT
    public final void mML_COMMENT() throws RecognitionException {
        try {
            int _type = ML_COMMENT;
            // Vmadl__.g:184:3: ( '/*' ( options {greedy=false; } : . )* '*/' )
            // Vmadl__.g:184:5: '/*' ( options {greedy=false; } : . )* '*/'
            {
            match("/*"); 

            // Vmadl__.g:184:10: ( options {greedy=false; } : . )*
            loop5:
            do {
                int alt5=2;
                int LA5_0 = input.LA(1);

                if ( (LA5_0=='*') ) {
                    int LA5_1 = input.LA(2);

                    if ( (LA5_1=='/') ) {
                        alt5=2;
                    }
                    else if ( ((LA5_1>='\u0000' && LA5_1<='.')||(LA5_1>='0' && LA5_1<='\uFFFE')) ) {
                        alt5=1;
                    }


                }
                else if ( ((LA5_0>='\u0000' && LA5_0<=')')||(LA5_0>='+' && LA5_0<='\uFFFE')) ) {
                    alt5=1;
                }


                switch (alt5) {
            	case 1 :
            	    // Vmadl__.g:184:37: .
            	    {
            	    matchAny(); 

            	    }
            	    break;

            	default :
            	    break loop5;
                }
            } while (true);

            match("*/"); 

             channel=HIDDEN; 

            }

            this.type = _type;
        }
        finally {
        }
    }
    // $ANTLR end ML_COMMENT

    // $ANTLR start LBRACE
    public final void mLBRACE() throws RecognitionException {
        try {
            int _type = LBRACE;
            // Vmadl__.g:189:8: ( '{' )
            // Vmadl__.g:189:10: '{'
            {
            match('{'); 

            }

            this.type = _type;
        }
        finally {
        }
    }
    // $ANTLR end LBRACE

    // $ANTLR start RBRACE
    public final void mRBRACE() throws RecognitionException {
        try {
            int _type = RBRACE;
            // Vmadl__.g:190:8: ( '}' )
            // Vmadl__.g:190:10: '}'
            {
            match('}'); 

            }

            this.type = _type;
        }
        finally {
        }
    }
    // $ANTLR end RBRACE

    public void mTokens() throws RecognitionException {
        // Vmadl__.g:1:8: ( SERVICE | STARTUP | SHUTDOWN | EXPOSE | ADVICE | POINTCUT | REQUIRE | BOOT | FOR | T23 | T24 | SERVICE_NAME | DIGIT | SPECIAL | NEWLINE | WS | COMMENT | ML_COMMENT | LBRACE | RBRACE )
        int alt6=20;
        switch ( input.LA(1) ) {
        case 's':
            {
            switch ( input.LA(2) ) {
            case 'h':
                {
                int LA6_18 = input.LA(3);

                if ( (LA6_18=='u') ) {
                    int LA6_31 = input.LA(4);

                    if ( (LA6_31=='t') ) {
                        int LA6_40 = input.LA(5);

                        if ( (LA6_40=='d') ) {
                            int LA6_49 = input.LA(6);

                            if ( (LA6_49=='o') ) {
                                int LA6_57 = input.LA(7);

                                if ( (LA6_57=='w') ) {
                                    int LA6_64 = input.LA(8);

                                    if ( (LA6_64=='n') ) {
                                        int LA6_71 = input.LA(9);

                                        if ( (LA6_71=='-'||(LA6_71>='0' && LA6_71<='9')||(LA6_71>='A' && LA6_71<='Z')||LA6_71=='_'||(LA6_71>='a' && LA6_71<='z')) ) {
                                            alt6=12;
                                        }
                                        else {
                                            alt6=3;}
                                    }
                                    else {
                                        alt6=12;}
                                }
                                else {
                                    alt6=12;}
                            }
                            else {
                                alt6=12;}
                        }
                        else {
                            alt6=12;}
                    }
                    else {
                        alt6=12;}
                }
                else {
                    alt6=12;}
                }
                break;
            case 'e':
                {
                int LA6_19 = input.LA(3);

                if ( (LA6_19=='r') ) {
                    int LA6_32 = input.LA(4);

                    if ( (LA6_32=='v') ) {
                        int LA6_41 = input.LA(5);

                        if ( (LA6_41=='i') ) {
                            int LA6_50 = input.LA(6);

                            if ( (LA6_50=='c') ) {
                                int LA6_58 = input.LA(7);

                                if ( (LA6_58=='e') ) {
                                    int LA6_65 = input.LA(8);

                                    if ( (LA6_65=='-'||(LA6_65>='0' && LA6_65<='9')||(LA6_65>='A' && LA6_65<='Z')||LA6_65=='_'||(LA6_65>='a' && LA6_65<='z')) ) {
                                        alt6=12;
                                    }
                                    else {
                                        alt6=1;}
                                }
                                else {
                                    alt6=12;}
                            }
                            else {
                                alt6=12;}
                        }
                        else {
                            alt6=12;}
                    }
                    else {
                        alt6=12;}
                }
                else {
                    alt6=12;}
                }
                break;
            case 't':
                {
                int LA6_20 = input.LA(3);

                if ( (LA6_20=='a') ) {
                    int LA6_33 = input.LA(4);

                    if ( (LA6_33=='r') ) {
                        int LA6_42 = input.LA(5);

                        if ( (LA6_42=='t') ) {
                            int LA6_51 = input.LA(6);

                            if ( (LA6_51=='u') ) {
                                int LA6_59 = input.LA(7);

                                if ( (LA6_59=='p') ) {
                                    int LA6_66 = input.LA(8);

                                    if ( (LA6_66=='-'||(LA6_66>='0' && LA6_66<='9')||(LA6_66>='A' && LA6_66<='Z')||LA6_66=='_'||(LA6_66>='a' && LA6_66<='z')) ) {
                                        alt6=12;
                                    }
                                    else {
                                        alt6=2;}
                                }
                                else {
                                    alt6=12;}
                            }
                            else {
                                alt6=12;}
                        }
                        else {
                            alt6=12;}
                    }
                    else {
                        alt6=12;}
                }
                else {
                    alt6=12;}
                }
                break;
            default:
                alt6=12;}

            }
            break;
        case 'e':
            {
            int LA6_2 = input.LA(2);

            if ( (LA6_2=='x') ) {
                int LA6_21 = input.LA(3);

                if ( (LA6_21=='p') ) {
                    int LA6_34 = input.LA(4);

                    if ( (LA6_34=='o') ) {
                        int LA6_43 = input.LA(5);

                        if ( (LA6_43=='s') ) {
                            int LA6_52 = input.LA(6);

                            if ( (LA6_52=='e') ) {
                                int LA6_60 = input.LA(7);

                                if ( (LA6_60=='-'||(LA6_60>='0' && LA6_60<='9')||(LA6_60>='A' && LA6_60<='Z')||LA6_60=='_'||(LA6_60>='a' && LA6_60<='z')) ) {
                                    alt6=12;
                                }
                                else {
                                    alt6=4;}
                            }
                            else {
                                alt6=12;}
                        }
                        else {
                            alt6=12;}
                    }
                    else {
                        alt6=12;}
                }
                else {
                    alt6=12;}
            }
            else {
                alt6=12;}
            }
            break;
        case 'a':
            {
            int LA6_3 = input.LA(2);

            if ( (LA6_3=='d') ) {
                int LA6_22 = input.LA(3);

                if ( (LA6_22=='v') ) {
                    int LA6_35 = input.LA(4);

                    if ( (LA6_35=='i') ) {
                        int LA6_44 = input.LA(5);

                        if ( (LA6_44=='c') ) {
                            int LA6_53 = input.LA(6);

                            if ( (LA6_53=='e') ) {
                                int LA6_61 = input.LA(7);

                                if ( (LA6_61=='-'||(LA6_61>='0' && LA6_61<='9')||(LA6_61>='A' && LA6_61<='Z')||LA6_61=='_'||(LA6_61>='a' && LA6_61<='z')) ) {
                                    alt6=12;
                                }
                                else {
                                    alt6=5;}
                            }
                            else {
                                alt6=12;}
                        }
                        else {
                            alt6=12;}
                    }
                    else {
                        alt6=12;}
                }
                else {
                    alt6=12;}
            }
            else {
                alt6=12;}
            }
            break;
        case 'p':
            {
            int LA6_4 = input.LA(2);

            if ( (LA6_4=='o') ) {
                int LA6_23 = input.LA(3);

                if ( (LA6_23=='i') ) {
                    int LA6_36 = input.LA(4);

                    if ( (LA6_36=='n') ) {
                        int LA6_45 = input.LA(5);

                        if ( (LA6_45=='t') ) {
                            int LA6_54 = input.LA(6);

                            if ( (LA6_54=='c') ) {
                                int LA6_62 = input.LA(7);

                                if ( (LA6_62=='u') ) {
                                    int LA6_69 = input.LA(8);

                                    if ( (LA6_69=='t') ) {
                                        int LA6_74 = input.LA(9);

                                        if ( (LA6_74=='-'||(LA6_74>='0' && LA6_74<='9')||(LA6_74>='A' && LA6_74<='Z')||LA6_74=='_'||(LA6_74>='a' && LA6_74<='z')) ) {
                                            alt6=12;
                                        }
                                        else {
                                            alt6=6;}
                                    }
                                    else {
                                        alt6=12;}
                                }
                                else {
                                    alt6=12;}
                            }
                            else {
                                alt6=12;}
                        }
                        else {
                            alt6=12;}
                    }
                    else {
                        alt6=12;}
                }
                else {
                    alt6=12;}
            }
            else {
                alt6=12;}
            }
            break;
        case 'r':
            {
            int LA6_5 = input.LA(2);

            if ( (LA6_5=='e') ) {
                int LA6_24 = input.LA(3);

                if ( (LA6_24=='q') ) {
                    int LA6_37 = input.LA(4);

                    if ( (LA6_37=='u') ) {
                        int LA6_46 = input.LA(5);

                        if ( (LA6_46=='i') ) {
                            int LA6_55 = input.LA(6);

                            if ( (LA6_55=='r') ) {
                                int LA6_63 = input.LA(7);

                                if ( (LA6_63=='e') ) {
                                    int LA6_70 = input.LA(8);

                                    if ( (LA6_70=='-'||(LA6_70>='0' && LA6_70<='9')||(LA6_70>='A' && LA6_70<='Z')||LA6_70=='_'||(LA6_70>='a' && LA6_70<='z')) ) {
                                        alt6=12;
                                    }
                                    else {
                                        alt6=7;}
                                }
                                else {
                                    alt6=12;}
                            }
                            else {
                                alt6=12;}
                        }
                        else {
                            alt6=12;}
                    }
                    else {
                        alt6=12;}
                }
                else {
                    alt6=12;}
            }
            else {
                alt6=12;}
            }
            break;
        case 'b':
            {
            int LA6_6 = input.LA(2);

            if ( (LA6_6=='o') ) {
                int LA6_25 = input.LA(3);

                if ( (LA6_25=='o') ) {
                    int LA6_38 = input.LA(4);

                    if ( (LA6_38=='t') ) {
                        int LA6_47 = input.LA(5);

                        if ( (LA6_47=='-'||(LA6_47>='0' && LA6_47<='9')||(LA6_47>='A' && LA6_47<='Z')||LA6_47=='_'||(LA6_47>='a' && LA6_47<='z')) ) {
                            alt6=12;
                        }
                        else {
                            alt6=8;}
                    }
                    else {
                        alt6=12;}
                }
                else {
                    alt6=12;}
            }
            else {
                alt6=12;}
            }
            break;
        case 'f':
            {
            int LA6_7 = input.LA(2);

            if ( (LA6_7=='o') ) {
                int LA6_26 = input.LA(3);

                if ( (LA6_26=='r') ) {
                    int LA6_39 = input.LA(4);

                    if ( (LA6_39=='-'||(LA6_39>='0' && LA6_39<='9')||(LA6_39>='A' && LA6_39<='Z')||LA6_39=='_'||(LA6_39>='a' && LA6_39<='z')) ) {
                        alt6=12;
                    }
                    else {
                        alt6=9;}
                }
                else {
                    alt6=12;}
            }
            else {
                alt6=12;}
            }
            break;
        case ';':
            {
            alt6=10;
            }
            break;
        case '#':
            {
            alt6=11;
            }
            break;
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
        case 'G':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'R':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'c':
        case 'd':
        case 'g':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'q':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':
            {
            alt6=12;
            }
            break;
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
            {
            alt6=13;
            }
            break;
        case '/':
            {
            switch ( input.LA(2) ) {
            case '*':
                {
                alt6=18;
                }
                break;
            case '/':
                {
                alt6=17;
                }
                break;
            default:
                alt6=14;}

            }
            break;
        case '\n':
        case '\r':
            {
            alt6=15;
            }
            break;
        case '\t':
        case ' ':
            {
            alt6=16;
            }
            break;
        case '!':
        case '\"':
        case '%':
        case '&':
        case '\'':
        case '(':
        case ')':
        case '*':
        case '+':
        case ',':
        case '-':
        case '.':
        case ':':
        case '<':
        case '=':
        case '>':
        case '[':
        case '\\':
        case ']':
        case '_':
        case '|':
            {
            alt6=14;
            }
            break;
        case '{':
            {
            alt6=19;
            }
            break;
        case '}':
            {
            alt6=20;
            }
            break;
        default:
            NoViableAltException nvae =
                new NoViableAltException("1:1: Tokens : ( SERVICE | STARTUP | SHUTDOWN | EXPOSE | ADVICE | POINTCUT | REQUIRE | BOOT | FOR | T23 | T24 | SERVICE_NAME | DIGIT | SPECIAL | NEWLINE | WS | COMMENT | ML_COMMENT | LBRACE | RBRACE );", 6, 0, input);

            throw nvae;
        }

        switch (alt6) {
            case 1 :
                // Vmadl__.g:1:10: SERVICE
                {
                mSERVICE(); 

                }
                break;
            case 2 :
                // Vmadl__.g:1:18: STARTUP
                {
                mSTARTUP(); 

                }
                break;
            case 3 :
                // Vmadl__.g:1:26: SHUTDOWN
                {
                mSHUTDOWN(); 

                }
                break;
            case 4 :
                // Vmadl__.g:1:35: EXPOSE
                {
                mEXPOSE(); 

                }
                break;
            case 5 :
                // Vmadl__.g:1:42: ADVICE
                {
                mADVICE(); 

                }
                break;
            case 6 :
                // Vmadl__.g:1:49: POINTCUT
                {
                mPOINTCUT(); 

                }
                break;
            case 7 :
                // Vmadl__.g:1:58: REQUIRE
                {
                mREQUIRE(); 

                }
                break;
            case 8 :
                // Vmadl__.g:1:66: BOOT
                {
                mBOOT(); 

                }
                break;
            case 9 :
                // Vmadl__.g:1:71: FOR
                {
                mFOR(); 

                }
                break;
            case 10 :
                // Vmadl__.g:1:75: T23
                {
                mT23(); 

                }
                break;
            case 11 :
                // Vmadl__.g:1:79: T24
                {
                mT24(); 

                }
                break;
            case 12 :
                // Vmadl__.g:1:83: SERVICE_NAME
                {
                mSERVICE_NAME(); 

                }
                break;
            case 13 :
                // Vmadl__.g:1:96: DIGIT
                {
                mDIGIT(); 

                }
                break;
            case 14 :
                // Vmadl__.g:1:102: SPECIAL
                {
                mSPECIAL(); 

                }
                break;
            case 15 :
                // Vmadl__.g:1:110: NEWLINE
                {
                mNEWLINE(); 

                }
                break;
            case 16 :
                // Vmadl__.g:1:118: WS
                {
                mWS(); 

                }
                break;
            case 17 :
                // Vmadl__.g:1:121: COMMENT
                {
                mCOMMENT(); 

                }
                break;
            case 18 :
                // Vmadl__.g:1:129: ML_COMMENT
                {
                mML_COMMENT(); 

                }
                break;
            case 19 :
                // Vmadl__.g:1:140: LBRACE
                {
                mLBRACE(); 

                }
                break;
            case 20 :
                // Vmadl__.g:1:147: RBRACE
                {
                mRBRACE(); 

                }
                break;

        }

    }


 

}