#include "Interpreter_internal.h"
#include <vmobjects/VMMethod.h>

pVMFrame frame;
void** pc;

void** pc_from_index(pVMMethod _method, int index) {
    uint8_t* bytecodes = ((uint8_t*)&_method->fields[SEND(_method, _get_offset) + 
                                                     SEND(_method, get_number_of_indexable_fields)
                                                    ]);
    
    void** _pc = (void**)&(bytecodes[SEND(_method, get_number_of_bytecodes)]) + index;
    return _pc;
}

int index_from_pc(pVMMethod _method, void** _pc) {
    uint8_t* bytecodes = ((uint8_t*)&_method->fields[SEND(_method, _get_offset) + 
                                                     SEND(_method, get_number_of_indexable_fields)
                                                     ]);
    
    void** base = (void**)&(bytecodes[SEND(_method, get_number_of_bytecodes)]);
     // TODO: consider 64bit
    int index = (int)(_pc - base);
    return index;
}
