#ifndef SIGNAL_H_
#define SIGNAL_H_

#include <module.VMObjects>

extern "C" {

/** Blocking wait for this signal */
void _Signal_wait(pVMObject object, pVMFrame frame);
/** Signal one waiting Thread */
void _Signal_signal(pVMObject object, pVMFrame frame);
/** Wakes up all the Threads waiting for the signal */
void _Signal_signalAll(pVMObject object, pVMFrame frame);

/** creates a new Signal Object with encapsulated pthread signal */
void Signal_new(pVMObject object, pVMFrame frame);

}

#endif /*CORE_SIGNAL_H_*/
